package projektsystemGUI;
import projektsystemFunktioner.*;
import projektsystemKerne.*;
import bjbupack.util.Convert;
import bjbupack.gui.SelectDialog;
import java.awt.*;
import java.awt.event.*;
import java.util.Iterator;
import java.util.Date;
import java.sql.*;  
import java.awt.Rectangle;
import java.awt.Dimension;
/**
  * GUI-Klassen til at nedlgge Aktivitet
  * @version  Februar 2003
  * @author   Bjrk Boye Busch  
*/  

public  class AktivitetFaerdigDialog extends Dialog
{
  private Frame    owner;

  private Aktivitet    aktivitet;     // aktuel model-objekt

  private Button       knapFaerdig = new Button     ();
  private Button       knapRetur   = new Button     ();

  private Label         labelBetegnelse      = new Label ();
  private TextField     betegnelse           = new TextField ();
  private Label         labelFaerdigDato     = new Label ();
  private TextField     faerdigDato          = new TextField ();

  public AktivitetFaerdigDialog (Frame ownerFrame, Aktivitet aktivitet)
    {
      super(ownerFrame, true/*modal*/);
      this.owner = ownerFrame;
      this.aktivitet = aktivitet;
    try
    {
      jbInit();
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }
  public void jbInit ()  throws Exception
  {
    this.setLayout(null);

    this.setSize(new Dimension(498, 223));
    this.setTitle("Frdig aktivitet");

    knapFaerdig.setLabel("Registrer");
    knapFaerdig.setBounds(new Rectangle(380, 35, 105, 25));
    knapRetur.setLabel("Fortryd");
    knapRetur.setBounds(new Rectangle(380, 65, 105, 25));

    labelBetegnelse.setText("Betegnelse:");
    labelBetegnelse.setBounds(new Rectangle(10, 40, 75, 20));
    labelFaerdigDato.setText("FaerdigDato:");
    labelFaerdigDato.setBounds(new Rectangle(10, 65, 75, 15));

    betegnelse.setEnabled(false);
    betegnelse.setBounds(new Rectangle(95, 40, 265, 20));
    faerdigDato.setEnabled(true);
    faerdigDato.setBounds(new Rectangle(95, 65, 75, 20));

    this.add(labelBetegnelse, null);
    this.add(betegnelse, null);
    this.add(labelFaerdigDato, null);
    this.add(faerdigDato, null);
    this.add(knapFaerdig);
    this.add(knapRetur);

    this.addWindowListener ( new AktivitetFaerdig_WindowClosing(this) );
    knapFaerdig.addActionListener(new AktivitetFaerdig_knapFaerdig_actionAdapter(this));
    knapRetur.addActionListener(new AktivitetFaerdig_knapRetur_actionAdapter(this));

    betegnelse.setText(""+aktivitet.getBetegnelse());
    faerdigDato.setText((new Timestamp((new Date()).getTime())).toString().substring(0,19));

  }

  //=================================================================

  public void aktivitetFaerdig ()
  {
      aktivitet.faerdigmeld ( Timestamp.valueOf(faerdigDato.getText()) );
      closeWindow();
  }

  public void closeWindow ()
  {
    this.dispose();
  }

  //=================================================================
}

class AktivitetFaerdig_WindowClosing extends WindowAdapter
{
  AktivitetFaerdigDialog   adaptee;
  AktivitetFaerdig_WindowClosing(AktivitetFaerdigDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void windowClosing(WindowEvent e)
  { adaptee.closeWindow ();  }
}

class AktivitetFaerdig_knapFaerdig_actionAdapter implements java.awt.event.ActionListener
{
  AktivitetFaerdigDialog   adaptee;
  AktivitetFaerdig_knapFaerdig_actionAdapter(AktivitetFaerdigDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.aktivitetFaerdig();  }
}
class AktivitetFaerdig_knapRetur_actionAdapter implements java.awt.event.ActionListener
{
  AktivitetFaerdigDialog   adaptee;
  AktivitetFaerdig_knapRetur_actionAdapter(AktivitetFaerdigDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.closeWindow();  }
}


