package projektsystemGUI;
import projektsystemFunktioner.*;
import projektsystemKerne.*;
import bjbupack.util.Convert;
import bjbupack.gui.SelectDialog;
import java.awt.*;
import java.awt.event.*;
import java.util.Iterator;
import java.util.Vector;
import java.util.Date;
import java.sql.*;  
import java.awt.Rectangle;
import java.awt.Dimension;
/**
  * GUI-Klassen til oprettelse af aktivitet
  * @version  Februar 2003
  * @author   Bjrk Boye Busch
*/


public  class AktivitetOpretDialog extends Dialog
{
  private Frame    owner;

  private Projekt      projekt;        // aktuel udvalgt model-objekt
  private Medarbejder  medarbejder;        // aktuel udvalgt model-objekt
  private Aktivitet    aktivitet;      // aktuel udvalgt model-objekt

  private Button       knapMedarbejder  = new Button     ();
  private Button       knapAdd     = new Button     ();
  private Button       knapClear   = new Button     ();
  private Button       knapReturn  = new Button     ();
  private TextArea     events      = new TextArea   ();

  private Label         labelProjektBetegnelse      = new Label ();
  private TextField     projektBetegnelse           = new TextField ();
  private Label         labelMedarbejderNavn        = new Label ();
  private TextField     medarbejderNavn             = new TextField ();
  private Label         labelBetegnelse      = new Label ();
  private TextField     betegnelse           = new TextField ();
  private Label         labelEtableringsDato = new Label ();
  private TextField     etableringsDato      = new TextField ();


  public AktivitetOpretDialog (Frame ownerFrame, Projekt projekt)
  {
    super(ownerFrame, true/*modal*/);
    this.owner = ownerFrame;
    this.projekt = projekt;
    try
    {
      jbInit();
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }
  public void jbInit ()  throws Exception
  {
    this.setLayout(null);
    this.setSize(new Dimension(524, 401));
    this.setTitle("Aktivitet oprettelse");

    knapMedarbejder.setLabel("Medarbejder");
    knapMedarbejder.setBounds(new Rectangle(405, 65, 105, 25));
    knapAdd.setLabel("Opret");
    knapAdd.setBounds(new Rectangle(405, 100, 105, 25));
    knapClear.setLabel("Blank");
    knapClear.setBounds(new Rectangle(405, 130, 105, 25));
    knapReturn.setLabel("Retur");
    knapReturn.setBounds(new Rectangle(405, 170, 105, 25));
    events.setBounds(new Rectangle(10, 210, 500, 150));


    labelProjektBetegnelse.setText("Projekt:");
    labelProjektBetegnelse.setBounds(new Rectangle(10, 45, 75, 20));
    projektBetegnelse.setBounds(new Rectangle(110, 45, 280, 20));
    labelMedarbejderNavn.setText("Medarbejder:");
    labelMedarbejderNavn.setBounds(new Rectangle(10, 70, 75, 20));
    medarbejderNavn.setBounds(new Rectangle(110, 70, 280, 20));
    labelBetegnelse.setText("Betegnelse:");
    labelBetegnelse.setBounds(new Rectangle(10, 105, 75, 20));
    betegnelse.setBounds(new Rectangle(110, 105, 280, 20));
    labelEtableringsDato.setText("EtableringsDato:");
    labelEtableringsDato.setBounds(new Rectangle(10, 130, 90, 20));
    etableringsDato.setBounds(new Rectangle(110, 130, 75, 20));
    this.add(labelProjektBetegnelse, null);
    this.add(projektBetegnelse, null);
    this.add(labelMedarbejderNavn, null);
    this.add(medarbejderNavn, null);
    this.add(labelBetegnelse, null);
    this.add(betegnelse, null);
    this.add(labelEtableringsDato, null);
    this.add(etableringsDato, null);
    this.add(knapMedarbejder);
    this.add(knapAdd);
    this.add(knapClear);
    this.add(knapReturn);

    this.add(events);
  
    events.setEnabled(false);
    events.setRows(8);
    events.setColumns(90);

    this.addWindowListener ( new AktivitetOpret_WindowClosing(this) );
    knapMedarbejder.addActionListener(new AktivitetOpret_knapMedarbejder_Action(this));
    knapAdd.addActionListener(new AktivitetOpret_knapAdd_Action(this));
    knapClear.addActionListener(new AktivitetOpret_knapClear_Action(this));
    knapReturn.addActionListener(new AktivitetOpret_knapReturn_Action(this));

    projektBetegnelse.setText(projekt.getBetegnelse());
    projektBetegnelse.setEnabled(false);
    medarbejderNavn.setEnabled(false);
    etableringsDato.setText((new Timestamp((new Date()).getTime())).toString().substring(0,19));
    knapAdd.setEnabled(false);
  }

  //=================================================================
  public void clearScreen ()
  {
    aktivitet = null;
    this.betegnelse.setText("");
    this.etableringsDato.setText("");
  }
  
  public void addAktivitet ()
  {
    try
    {
      aktivitet = projekt.opretAktivitet( betegnelse.getText(),
                                          Timestamp.valueOf(etableringsDato.getText()),
                                          medarbejder);
      if (aktivitet != null)
      {
        events.append(aktivitet.toString());
        events.append(": oprettet\n");
      }
      else
        events.append(": Fejl ved oprettelse\n");
    }
    catch (Exception e)
    {
      events.append(": Fejl i inddate ved oprettelse:\n");
    }
  }

  public void selectMedarbejder ()
  {

    Iterator  iterator = MedarbejderFunktioner.ansatteMedarbejdereIterator();
    SelectDialog  selectDialog = new SelectDialog(this.owner,"Medarbejder",true,iterator,15,true);
    selectDialog.setSize(600,400);
    selectDialog.setVisible(true);

    Object[]  ov  =  selectDialog.getSelectedObjects();
    if ((ov!=null)&&(ov.length>0))
    {
      medarbejder = (Medarbejder)ov[0];
      medarbejderNavn.setText(medarbejder.getFornavn()+" "+
                              medarbejder.getEfternavn());
      knapAdd.setEnabled(true);
    }
    else
    {
      medarbejderNavn.setText("");
      knapAdd.setEnabled(false);
    }
  }
  
  public Aktivitet getAktivitet()
  { return aktivitet;  }

  public void closeWindow ()
  {
     this.dispose();
  }
  
  //=================================================================
}

class AktivitetOpret_WindowClosing extends WindowAdapter
{
  AktivitetOpretDialog   adaptee;
  AktivitetOpret_WindowClosing(AktivitetOpretDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void windowClosing(WindowEvent e)
  { adaptee.closeWindow ();  }
}


class AktivitetOpret_knapMedarbejder_Action implements java.awt.event.ActionListener
{
  AktivitetOpretDialog   adaptee;
  AktivitetOpret_knapMedarbejder_Action(AktivitetOpretDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.selectMedarbejder();  }
}

class AktivitetOpret_knapAdd_Action implements java.awt.event.ActionListener
{
  AktivitetOpretDialog   adaptee;
  AktivitetOpret_knapAdd_Action(AktivitetOpretDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.addAktivitet();  }
}

class AktivitetOpret_knapClear_Action implements java.awt.event.ActionListener
{
  AktivitetOpretDialog   adaptee;
  AktivitetOpret_knapClear_Action(AktivitetOpretDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.clearScreen();  }
}
class AktivitetOpret_knapReturn_Action implements java.awt.event.ActionListener
{
  AktivitetOpretDialog   adaptee;
  AktivitetOpret_knapReturn_Action(AktivitetOpretDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.closeWindow();  }
}
