package projektsystemGUI;
import projektsystemFunktioner.*;
import projektsystemKerne.*;
import bjbupack.util.Convert;
import bjbupack.gui.SelectDialog;
import java.awt.*;
import java.awt.event.*;
import java.util.Iterator;
import java.sql.*;  
import java.awt.Rectangle;
import java.awt.Dimension;
/**
  * GUI-Klassen til at rette stamdata for Aktivitet
  * @version  Februar 2003
  * @author   Bjrk Boye Busch
*/

public  class AktivitetRetStamdataDialog extends Dialog
{
  private Frame    owner;

  private Aktivitet   aktivitet;     // aktuel model-objekt

  private Button       knapReplace = new Button     ();
  private Button       knapRetur   = new Button     ();

  private Label         labelPostnr          = new Label ();
  private TextField     postnr               = new TextField ();
  private Label         labelBetegnelse        = new Label ();
  private TextField     betegnelse             = new TextField ();


    public AktivitetRetStamdataDialog (Frame ownerFrame, Aktivitet aktivitet)
    {
      super(ownerFrame, true/*modal*/);
      this.owner = ownerFrame;
      this.aktivitet = aktivitet;
    try
    {
      jbInit();
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }
  public void jbInit ()  throws Exception
  {
    this.setSize(new Dimension(506, 132));
    this.setTitle("ndring af aktivitet stamdata");

    this.setLayout(null);
  
    knapReplace.setLabel("Opdatering");
    knapReplace.setBounds(new Rectangle(395, 40, 90, 25));
    knapRetur.setLabel("Fortryd");
    knapRetur.setBounds(new Rectangle(395, 75, 90, 25));

    postnr.setBounds(new Rectangle(80, 45, 40, 20));
    labelBetegnelse.setText("Betegnelse:");
    labelBetegnelse.setBounds(new Rectangle(15, 40, 60, 20));
    betegnelse.setBounds(new Rectangle(105, 40, 275, 20));
    this.add(labelPostnr, null);
    this.add(labelBetegnelse, null);

    this.add(betegnelse, null);
    this.add(knapReplace);
    this.add(knapRetur);

    this.addWindowListener ( new AktivitetRetStamdata_WindowClosing(this) );
    knapReplace.addActionListener(new AktivitetRetStamdata_knapReplace_actionAdapter(this));
    knapRetur.addActionListener(new AktivitetRetStamdata_knapRetur_actionAdapter(this));

    betegnelse.setText(""+aktivitet.getBetegnelse());

  }

  //=================================================================

  public void replaceAktivitet ()
  {
     aktivitet.retStamdata ( betegnelse.getText() );
     closeWindow();
  }

  public void closeWindow ()
  {
     this.dispose();
  }

  //=================================================================
}

class AktivitetRetStamdata_WindowClosing extends WindowAdapter
{
  AktivitetRetStamdataDialog   adaptee;
  AktivitetRetStamdata_WindowClosing(AktivitetRetStamdataDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void windowClosing(WindowEvent e)
  { adaptee.closeWindow ();  }
}

class AktivitetRetStamdata_knapReplace_actionAdapter implements java.awt.event.ActionListener
{
  AktivitetRetStamdataDialog   adaptee;
  AktivitetRetStamdata_knapReplace_actionAdapter(AktivitetRetStamdataDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.replaceAktivitet();  }
}
class AktivitetRetStamdata_knapRetur_actionAdapter implements java.awt.event.ActionListener
{
  AktivitetRetStamdataDialog   adaptee;
  AktivitetRetStamdata_knapRetur_actionAdapter(AktivitetRetStamdataDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.closeWindow();  }
}


