package projektsystemGUI;
import projektsystemFunktioner.*;
import projektsystemKerne.*;
import bjbupack.util.Convert;
import bjbupack.gui.SelectDialog;
import java.awt.*;
import java.awt.event.*;
import java.util.Iterator;
import java.sql.*;  
import java.awt.Dimension;
import java.awt.Color;
import java.awt.SystemColor;
import java.awt.Rectangle;
import java.awt.Panel;
import java.awt.GridLayout;
/**  
  * Hoved billede for projekt system
  * @version  Februar 2003
  * @author   Bjrk Boye Busch  
*/  

public  class MainFrame extends Frame
{

  private MenuBar    menuBar              = new MenuBar();
  private Menu       menuFile             = new Menu("File");
  private MenuItem   itemFileExit         = new MenuItem("Exit");
  private Menu       menuProjekt          = new Menu("Projekter");
  private MenuItem   itemProjektAdm       = new MenuItem("Projekter handling");
  private Menu       menuMedarbejder      = new Menu("Medarbejder");
  private MenuItem   itemMedarbejderAdm   = new MenuItem("Medarbejder handling");
  private Menu       menuDiverse          = new Menu("Diverse");
  private MenuItem   itemPostdistriktAdm  = new MenuItem("Postdistrikter");

  ProjektAdmPanel          projektAdmPanel = null;
  MedarbejderAdmPanel      medarbejderAdmPanel = null;
  PostdistriktAdmDialog    postdistriktAdmDialog = null;

  public MainFrame ()
  {
    try
    {
      jbInit();
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }
  public void jbInit ()  throws Exception
  {
    GlobalModel.open();

    this.setSize(new Dimension(700, 350));
    this.setTitle("Projekt system");
    this.setLayout(null);

    setMenuBar(menuBar);
    menuBar.add(menuFile);
    menuFile.add(itemFileExit);
    menuBar.add(menuProjekt);
    menuProjekt.add(itemProjektAdm);
    menuBar.add(menuMedarbejder);
    menuMedarbejder.add(itemMedarbejderAdm);
    menuBar.add(menuDiverse);
    menuDiverse.add(itemPostdistriktAdm);

    projektAdmPanel = new ProjektAdmPanel(this);
    this.add(projektAdmPanel);
    this.setTitle("Projekt system - Projekter");
    
    this.addWindowListener ( new MainFrame_WindowClosing(this) );
    itemFileExit.addActionListener(new MainFrame_FileExit_Action(this));
    itemMedarbejderAdm.addActionListener(new MainFrame_MedarbejderAdm_Action(this));
    itemProjektAdm.addActionListener(new MainFrame_ProjektAdm_Action(this));
    itemPostdistriktAdm.addActionListener(new MainFrame_PostdistriktAdm_Action(this));
  }

  public void projektAdm ()
  {
    this.setTitle("Projekt system - Projekter");
    if (projektAdmPanel == null)
    {
        projektAdmPanel = new ProjektAdmPanel(this);
        this.add(projektAdmPanel);
    }
    projektAdmPanel.setVisible(true);
    if (medarbejderAdmPanel != null)
      medarbejderAdmPanel.setVisible(false);
  }
  
  public void medarbejderAdm ()
  {
    this.setTitle("Projekt system - Medarbejder");
    if (medarbejderAdmPanel == null)
    {
        medarbejderAdmPanel = new MedarbejderAdmPanel(this);
        this.add(medarbejderAdmPanel);
    }
    medarbejderAdmPanel.setVisible(true);
    if (projektAdmPanel != null)
      projektAdmPanel.setVisible(false);
  }
  public void postdistriktAdm ()
  {
    if (postdistriktAdmDialog == null) postdistriktAdmDialog  = new PostdistriktAdmDialog (this);
    postdistriktAdmDialog.setVisible(true);
  }

  public void closeWindow ()
  {
     exit();
  }
  public void exit ()
  {
    GlobalModel.close();
    System.exit(0);
  }
 
}

//=================================================================

class MainFrame_WindowClosing extends WindowAdapter
{
  MainFrame   adaptee;
  MainFrame_WindowClosing(MainFrame  adaptee)
  {  this.adaptee = adaptee; }
  public void windowClosing(WindowEvent e)
  { adaptee.closeWindow ();  }
    
}

class MainFrame_FileExit_Action implements java.awt.event.ActionListener
{
  MainFrame   adaptee;
  MainFrame_FileExit_Action(MainFrame  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.exit();  }
}

class MainFrame_MedarbejderAdm_Action implements java.awt.event.ActionListener
{
  MainFrame   adaptee;
  MainFrame_MedarbejderAdm_Action(MainFrame  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.medarbejderAdm();  }
}

class MainFrame_ProjektAdm_Action implements java.awt.event.ActionListener
{
  MainFrame   adaptee;
  MainFrame_ProjektAdm_Action(MainFrame  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.projektAdm();  }
}

class MainFrame_PostdistriktAdm_Action implements java.awt.event.ActionListener
{
  MainFrame   adaptee;
  MainFrame_PostdistriktAdm_Action(MainFrame  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.postdistriktAdm();  }
}
