package projektsystemGUI;
import projektsystemFunktioner.*;
import projektsystemKerne.*;
import bjbupack.util.Convert;
import bjbupack.gui.SelectDialog;
import java.awt.*;
import java.awt.event.*;
import java.util.Iterator;
import java.sql.*;
import java.awt.Rectangle;
import java.awt.Dimension;
import javax.swing.JPanel;
import javax.swing.border.EtchedBorder;
/**
  * GUI-Klassen medarbejderAdministration
  * @version  Februar 2003
  * @author   Bjrk Boye Busch
*/

public  class MedarbejderAdmPanel extends JPanel
{

  private Medarbejder  medarbejder;

  private Frame        ownerFrame;

  private Button       knapSelect  = new Button     ();
  private Button       knapReplace = new Button     ();
  private Button       knapAdd     = new Button     ();
  private Button       knapAfgaaet = new Button     ();
  private Button       knapRemove  = new Button     ();
  private Button       knapAktiviteter = new Button     ();
  private Button       knapOpretTimeforbrug = new Button     ();
//  private Button       knapReturn  = new Button     ();    // med i Dialog

  private Label         labelFornavn         = new Label ();
  private TextField     fornavn              = new TextField ();
  private Label         labelEfternavn       = new Label ();
  private TextField     efternavn            = new TextField ();
  private Label         labelGade            = new Label ();
  private TextField     gade                 = new TextField ();
  private Label         labelPostnr          = new Label ();
  private TextField     postnr               = new TextField ();
  private Label         labelDistrikt        = new Label ();
  private TextField     distrikt             = new TextField ();
  private Label         labelTlf             = new Label ();
  private TextField     tlf                  = new TextField ();
  private Label         labelAnsatDato       = new Label ();
  private TextField     ansatDato            = new TextField ();
  private Label         labelAfgaaetDato     = new Label ();
  private TextField     afgaaetDato          = new TextField ();
  private Label         labelAfgaaetAarsag   = new Label ();
  private TextField     afgaaetAarsag        = new TextField ();
  private Label         labelTilstand        = new Label ();
  private TextField     tilstand             = new TextField ();


  public MedarbejderAdmPanel (Frame ownerFrame)
  {
//    super(ownerFrame, true/*modal*/);   // Med i Dialog udgave
    this.ownerFrame = ownerFrame;
    try
    {
      jbInit();
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }
  public void jbInit ()  throws Exception
  {
    this.setSize(new Dimension(572, 356));       // af hensyn til tegning med JDeveloper
//    this.setTitle("Medarbejder");            // Kun med i dialog
    Dimension dim = this.ownerFrame.getSize();
    this.setBounds(new Rectangle(3, 43, (int)dim.getWidth()-6, (int)dim.getHeight()-27)); // Med som strrelse i Panel
    this.setBorder(new EtchedBorder());// med p paneludgave for at adskille
    this.setBackground(SystemColor.text);
    this.setLayout(null);

    knapSelect.setLabel("Vlg medarbejder");
    knapSelect.setBounds(new Rectangle(500, 40, 140, 25));
    knapReplace.setLabel("Ret stamdata");
    knapReplace.setBounds(new Rectangle(500, 115, 140, 25));
    knapAdd.setLabel("Opret ny medarbejder");
    knapAdd.setBounds(new Rectangle(500, 70, 140, 25));
    knapAfgaaet.setLabel("Medarbejder afgr");
    knapAfgaaet.setBounds(new Rectangle(500, 145, 140, 25));
    knapRemove.setLabel("Slet medarbejder");
    knapRemove.setBounds(new Rectangle(500, 175, 140, 25));
    knapAktiviteter.setLabel("Aktiviteter");
    knapAktiviteter.setBounds(new Rectangle(500, 220, 140, 25));
//    knapReturn.setLabel("Retur");   //Kun med i Dialog
//    knapReturn.setBounds(new Rectangle(500, 295, 140, 25));   //Kun med i Dialog

    labelFornavn.setText("Fornavn:");
    labelFornavn.setBounds(new Rectangle(50, 50, 45, 15));
    labelEfternavn.setText("Efternavn:");
    labelEfternavn.setBounds(new Rectangle(50, 75, 50, 15));
    labelGade.setText("Gade:");
    labelGade.setBounds(new Rectangle(50, 100, 35, 15));
    labelPostnr.setText("Postnr:");
    labelPostnr.setBounds(new Rectangle(50, 125, 40, 15));
    labelDistrikt.setText("By:");
    labelDistrikt.setBounds(new Rectangle(185, 125, 20, 15));
    labelTlf.setText("Tlf:");
    labelTlf.setBounds(new Rectangle(50, 150, 20, 15));
    labelAnsatDato.setText("AnsatDato:");
    labelAnsatDato.setBounds(new Rectangle(50, 175, 70, 15));
    labelAfgaaetDato.setText("AfgetDato:");
    labelAfgaaetDato.setBounds(new Rectangle(50, 200, 65, 15));
    labelAfgaaetAarsag.setText("rsag:");
    labelAfgaaetAarsag.setBounds(new Rectangle(225, 200, 40, 15));
    labelTilstand.setText("Tilstand:");
    labelTilstand.setBounds(new Rectangle(50, 225, 50, 15));

    fornavn.setEnabled(false);
    fornavn.setBounds(new Rectangle(135, 45, 270, 20));
    efternavn.setEnabled(false);
    efternavn.setBounds(new Rectangle(135, 70, 270, 20));
    gade.setEnabled(false);
    gade.setBounds(new Rectangle(135, 95, 270, 20));
    postnr.setEnabled(false);
    postnr.setBounds(new Rectangle(135, 120, 40, 20));
    distrikt.setEnabled(false);
    distrikt.setBounds(new Rectangle(215, 120, 190, 20));
    tlf.setEnabled(false);
    tlf.setBounds(new Rectangle(135, 145, 75, 20));
    ansatDato.setEnabled(false);
    ansatDato.setBounds(new Rectangle(135, 170, 75, 20));
    afgaaetDato.setEnabled(false);
    afgaaetDato.setBounds(new Rectangle(135, 195, 75, 20));
    afgaaetAarsag.setEnabled(false);
    afgaaetAarsag.setBounds(new Rectangle(270, 195, 75, 20));
    tilstand.setEnabled(false);
    tilstand.setBounds(new Rectangle(135, 220, 75, 20));

    this.add(knapSelect);
    this.add(knapReplace);
    this.add(knapAfgaaet);
    this.add(knapAdd);
    this.add(knapRemove);
    this.add(knapAktiviteter);
    this.add(labelFornavn, null);
    this.add(fornavn, null);
    this.add(labelEfternavn, null);
    this.add(efternavn, null);
    this.add(labelGade, null);
    this.add(gade, null);
    this.add(labelPostnr, null);
    this.add(postnr, null);
    this.add(labelDistrikt, null);
    this.add(distrikt, null);
    this.add(labelTlf, null);
    this.add(tlf, null);
    this.add(labelAnsatDato, null);
    this.add(ansatDato, null);
    this.add(labelAfgaaetDato, null);
    this.add(afgaaetDato, null);
    this.add(labelAfgaaetAarsag, null);
    this.add(afgaaetAarsag, null);
    this.add(labelTilstand, null);
    this.add(tilstand, null);
//    this.add(knapReturn);   //Kun med i Dialog


//    this.addWindowListener ( new MedarbejderAdm_WindowClosing(this) );   //Kun med i Dialog
    knapSelect.addActionListener(new MedarbejderAdm_knapSelect_Action(this));
    knapReplace.addActionListener(new MedarbejderAdm_knapReplace_Action(this));
    knapAdd.addActionListener(new MedarbejderAdm_knapAdd_Action(this));
    knapAfgaaet.addActionListener(new MedarbejderAdm_knapAfgaaet_Action(this));
    knapRemove.addActionListener(new MedarbejderAdm_knapRemove_Action(this));
    knapAktiviteter.addActionListener(new MedarbejderAdm_knapAktiviteter_Action(this));
//    knapReturn.addActionListener(new MedarbejderAdm_knapReturn_Action(this));   //Kun med i Dialog

    medarbejderToFrame ();
  }

  //=================================================================

  public void medarbejderToFrame ()
  {
    if (medarbejder==null)
    {
      this.fornavn.setText("");
      this.efternavn.setText("");
      this.gade.setText("");
      this.postnr.setText("");
      this.distrikt.setText("");
      this.tlf.setText("");
      this.ansatDato.setText("");
      this.afgaaetDato.setText("");
      this.afgaaetAarsag.setText("");
      this.tilstand.setText("");
      knapReplace.setEnabled(false);
      knapAfgaaet.setEnabled(false);
      knapRemove.setEnabled(false);
      knapAktiviteter.setEnabled(false);
    }
    else
    {
      this.fornavn.setText(""+medarbejder.getFornavn());
      this.efternavn.setText(""+medarbejder.getEfternavn());
      this.gade.setText(""+medarbejder.getGade());
      this.tlf.setText(""+medarbejder.getTlf());
      if ( medarbejder.getAnsatDato() == null )        this.ansatDato.setText("");
      else  this.ansatDato.setText(medarbejder.getAnsatDato().toString().substring(0,19));
      if ( medarbejder.getAfgaaetDato() == null )        this.afgaaetDato.setText("");
      else  this.afgaaetDato.setText(medarbejder.getAfgaaetDato().toString().substring(0,19));
      if (medarbejder.getTilstand() == Medarbejder.TILSTAND_AFGAAET)
      {
        this.tilstand.setText("Afget");
        if (medarbejder.getAfgaaetAarsag() == Medarbejder.AFGAAET_AARSAG_FYRET)
          this.afgaaetAarsag.setText("Fyret");
        else if (medarbejder.getAfgaaetAarsag() == Medarbejder.AFGAAET_AARSAG_SAGTOP)
          this.afgaaetAarsag.setText("Sagt op");
        else
          this.afgaaetAarsag.setText("");

      }
      else  this.tilstand.setText("Aktiv");
      knapReplace.setEnabled(true);
      knapAktiviteter.setEnabled(true);
      if (medarbejder.getTilstand() == Medarbejder.TILSTAND_ANSAT)
      {
        knapAfgaaet.setEnabled(true);
        knapRemove.setEnabled(false);
      }
      else if (medarbejder.getTilstand() == Medarbejder.TILSTAND_AFGAAET)
      {
        knapAfgaaet.setEnabled(false);
        knapRemove.setEnabled(true);
      }
      Postdistrikt  postdistrikt = medarbejder.getPostdistrikt();
      this.postnr.setText(""+postdistrikt.getPostnr());
      this.distrikt.setText(""+postdistrikt.getDistrikt());

    }
  }
  
  public void selectMedarbejder ()
  {
    Iterator  iterator = GlobalModel.getProjektsystem().getMedarbejderIterator();
    SelectDialog  selectDialog = new SelectDialog(this.ownerFrame,"Medarbejder",true,iterator,15,true);
    selectDialog.setSize(600,400);
    selectDialog.setVisible(true);

    Object[]  ov  =  selectDialog.getSelectedObjects();
    if ((ov!=null)&&(ov.length>0))
      medarbejder = (Medarbejder)ov[0];

    medarbejderToFrame ();
  }
  
  public void replaceMedarbejder ()
  {
    MedarbejderRetStamdataDialog  medarbejderRetStamdataDialog = new MedarbejderRetStamdataDialog(this.ownerFrame, this.medarbejder);
    medarbejderRetStamdataDialog.setVisible(true);
    medarbejderToFrame ();
  }
  
  public void afgaaetMedarbejder ()
  {
    MedarbejderAfgaaetDialog  medarbejderAfgaaetDialog = new MedarbejderAfgaaetDialog(this.ownerFrame, this.medarbejder);
    medarbejderAfgaaetDialog.setVisible(true);
    medarbejderToFrame ();
  }

  public void addMedarbejder ()
  {
    MedarbejderOpretDialog medarbejderOpretDialog  = new MedarbejderOpretDialog (this.ownerFrame);
    medarbejderOpretDialog.setVisible(true);
    medarbejder = medarbejderOpretDialog.getMedarbejder();
    medarbejderToFrame ();
  }
  
  public void removeMedarbejder ()
  {
    // IKKE IMPLEMENTERET
  }

  
  public void aktiviteter ()
  {
    if (medarbejder!=null)
    {
      Iterator  iterator = medarbejder.getAktivitetIterator();
      SelectDialog  selectDialog = new SelectDialog(this.ownerFrame,"Aktiviteter",true,iterator,15,true);
      selectDialog.setSize(600,400);
      selectDialog.setVisible(true);

      Object[]  ov  =  selectDialog.getSelectedObjects();
      if ((ov!=null)&&(ov.length>0))
      {
        Aktivitet aktivitet = (Aktivitet)ov[0];
        Projekt projekt = aktivitet.getProjekt();
        // opstart detail-billede for aktivitet, overfr projekt og aktivitet
        AktivitetAdmDialog aktivitetAdmDialog = new AktivitetAdmDialog (this.ownerFrame, projekt, aktivitet);
        aktivitetAdmDialog.setVisible(true);
      }
    }
  }

/*    Kun med i Dialog
  public void closeWindow ()
  {
    this.dispose();
  }
*/

}

//=================================================================

/*    Kun med i Dialog
class MedarbejderAdm_WindowClosing extends WindowAdapter
{
  MedarbejderAdmPanel   adaptee;
  MedarbejderAdm_WindowClosing(MedarbejderAdmPanel  adaptee)
  {  this.adaptee = adaptee; }
  public void windowClosing(WindowEvent e)
  { adaptee.closeWindow();  }
}
*/
class MedarbejderAdm_knapSelect_Action implements java.awt.event.ActionListener
{
  MedarbejderAdmPanel   adaptee;
  MedarbejderAdm_knapSelect_Action(MedarbejderAdmPanel   adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.selectMedarbejder();  }
}

class MedarbejderAdm_knapReplace_Action implements java.awt.event.ActionListener
{
  MedarbejderAdmPanel   adaptee;
  MedarbejderAdm_knapReplace_Action(MedarbejderAdmPanel   adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.replaceMedarbejder();  }
}

class MedarbejderAdm_knapAdd_Action implements java.awt.event.ActionListener
{
  MedarbejderAdmPanel   adaptee;
  MedarbejderAdm_knapAdd_Action(MedarbejderAdmPanel   adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.addMedarbejder();  }
}

class MedarbejderAdm_knapAfgaaet_Action implements java.awt.event.ActionListener
{
  MedarbejderAdmPanel   adaptee;
  MedarbejderAdm_knapAfgaaet_Action(MedarbejderAdmPanel   adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.afgaaetMedarbejder();  }
}

class MedarbejderAdm_knapRemove_Action implements java.awt.event.ActionListener
{
  MedarbejderAdmPanel   adaptee;
  MedarbejderAdm_knapRemove_Action(MedarbejderAdmPanel   adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.removeMedarbejder();  }
}

class MedarbejderAdm_knapAktiviteter_Action implements java.awt.event.ActionListener
{
  MedarbejderAdmPanel   adaptee;
  MedarbejderAdm_knapAktiviteter_Action(MedarbejderAdmPanel   adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.aktiviteter();  }
}

/*    Kun med i Dialog
class MedarbejderAdm_knapReturn_Action implements java.awt.event.ActionListener
{
  MedarbejderAdmPanel   adaptee;
  MedarbejderAdm_knapReturn_Action(MedarbejderAdmPanel  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.closeWindow();  }
}
*/
