package projektsystemGUI;
import projektsystemFunktioner.*;
import projektsystemKerne.*;
import bjbupack.util.Convert;
import bjbupack.gui.SelectDialog;
import java.awt.*;
import java.awt.event.*;
import java.util.Iterator;
import java.util.Date;
import java.sql.*;  
import java.awt.Rectangle;
import java.awt.Dimension;
import java.awt.Checkbox;
import java.awt.CheckboxGroup;
/**  
  * GUI-Klassen til at nedlgge Medarbejder
  * @version  Februar 2003
  * @author   Bjrk Boye Busch  
*/  

public  class MedarbejderAfgaaetDialog extends Dialog
{
  private Frame    owner;

  private Medarbejder    medarbejder;     // aktuel model-objekt

  private Button       knapAfgaaet = new Button     ();
  private Button       knapRetur   = new Button     ();

  private Label         labelFornavn         = new Label ();
  private TextField     fornavn              = new TextField ();
  private Label         labelEfternavn       = new Label ();
  private TextField     efternavn            = new TextField ();
  private Label         labelGade            = new Label ();
  private TextField     gade                 = new TextField ();
  private Label         labelPostnr          = new Label ();
  private TextField     postnr               = new TextField ();
  private Label         labelDistrikt        = new Label ();
  private TextField     distrikt              = new TextField ();
  private Label         labelTlf             = new Label ();
  private TextField     tlf                  = new TextField ();
  private Label         labelAfgaaetDato     = new Label ();
  private TextField     afgaaetDato          = new TextField ();
  private Label         labelTilstand        = new Label ();
  private CheckboxGroup afgaaetAarsag        = new CheckboxGroup();
  private Checkbox      afgaaetAarsag_Fyret  = new Checkbox();
  private Checkbox      afgaaetAarsag_Sagtop = new Checkbox();

  public MedarbejderAfgaaetDialog (Frame ownerFrame, Medarbejder medarbejder)
    {
      super(ownerFrame, true/*modal*/);
      this.owner = ownerFrame;
      this.medarbejder = medarbejder;
    try
    {
      jbInit();
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }
  public void jbInit ()  throws Exception
  {
    this.setLayout(null);
  
    this.setSize(new Dimension(498, 223));
    this.setTitle("Afget medarbejder");

    knapAfgaaet.setLabel("Registrer");
    knapAfgaaet.setBounds(new Rectangle(380, 35, 105, 25));
    knapRetur.setLabel("Fortryd");
    knapRetur.setBounds(new Rectangle(380, 65, 105, 25));

    labelFornavn.setText("Fornavn:");
    labelFornavn.setBounds(new Rectangle(10, 40, 50, 20));
    labelEfternavn.setText("Efternavn:");
    labelEfternavn.setBounds(new Rectangle(10, 65, 55, 20));
    labelGade.setText("Gade:");
    labelGade.setBounds(new Rectangle(10, 90, 35, 20));
    labelPostnr.setText("Postnr:");
    labelPostnr.setBounds(new Rectangle(10, 115, 40, 20));
    labelDistrikt.setText("By:");
    labelDistrikt.setBounds(new Rectangle(145, 115, 20, 20));
    labelTlf.setText("Tlf:");
    labelTlf.setBounds(new Rectangle(10, 140, 20, 20));
    labelAfgaaetDato.setText("AfgaaetDato:");
    labelAfgaaetDato.setBounds(new Rectangle(10, 165, 75, 15));
  
    fornavn.setEnabled(false);
    fornavn.setBounds(new Rectangle(95, 40, 265, 20));
    efternavn.setEnabled(false);
    efternavn.setBounds(new Rectangle(95, 65, 265, 20));
    gade.setEnabled(false);
    gade.setBounds(new Rectangle(95, 90, 265, 20));
    postnr.setEnabled(false);
    postnr.setBounds(new Rectangle(95, 115, 40, 20));
    distrikt.setEnabled(false);
    distrikt.setBounds(new Rectangle(170, 115, 190, 20));
    tlf.setEnabled(false);
    tlf.setBounds(new Rectangle(95, 140, 55, 20));
    afgaaetDato.setEnabled(true);
    afgaaetDato.setBounds(new Rectangle(95, 165, 70, 20));
    afgaaetAarsag_Fyret.setBounds(new Rectangle(175, 165, 45, 25));
    afgaaetAarsag_Fyret.setLabel("Fyret");
    afgaaetAarsag_Sagtop.setBounds(new Rectangle(225, 165, 65, 25));
    afgaaetAarsag_Sagtop.setLabel("Sagt op");

    this.add(labelFornavn, null);
    this.add(fornavn, null);
    this.add(labelEfternavn, null);
    this.add(efternavn, null);
    this.add(labelGade, null);
    this.add(gade, null);
    this.add(labelPostnr, null);
    this.add(postnr, null);
    this.add(labelDistrikt, null);
    this.add(distrikt, null);
    this.add(labelTlf, null);
    this.add(tlf, null);
    this.add(labelAfgaaetDato, null);
    this.add(afgaaetDato, null);
    this.add(knapAfgaaet);
    this.add(knapRetur);
    this.add(afgaaetAarsag_Fyret, null);
    this.add(afgaaetAarsag_Sagtop, null);
    afgaaetAarsag_Fyret.setCheckboxGroup(afgaaetAarsag);
    afgaaetAarsag_Sagtop.setCheckboxGroup(afgaaetAarsag);
  
    this.addWindowListener ( new MedarbejderAfgaaet_WindowClosing(this) );
    knapAfgaaet.addActionListener(new MedarbejderAfgaaet_knapAfgaaet_actionAdapter(this));
    knapRetur.addActionListener(new MedarbejderAfgaaet_knapRetur_actionAdapter(this));

    fornavn.setText(""+medarbejder.getFornavn());
    efternavn.setText(""+medarbejder.getEfternavn());
    gade.setText(""+medarbejder.getGade());
    Postdistrikt postdistrikt = medarbejder.getPostdistrikt();
    postnr.setText(""+postdistrikt.getPostnr());
    distrikt.setText(""+postdistrikt.getDistrikt());
    tlf.setText(""+medarbejder.getTlf());
    afgaaetDato.setText((new Timestamp((new Date()).getTime())).toString().substring(0,19));

  }
  
  //=================================================================
  
  public void medarbejderAfgaaet ()
  {
    if ( ( afgaaetAarsag_Fyret.getState() || afgaaetAarsag_Sagtop.getState() )
         && afgaaetDato.getText().trim().length()>0 )
    {
      int afgaaetAarsag_kode = Medarbejder.AFGAAET_AARSAG_FYRET;
      if (afgaaetAarsag_Sagtop.getState())
        afgaaetAarsag_kode = Medarbejder.AFGAAET_AARSAG_SAGTOP;
      medarbejder.afgaaet ( Timestamp.valueOf(afgaaetDato.getText()), afgaaetAarsag_kode );
      closeWindow();
    }
  }
  
  public void closeWindow ()
  {
    this.dispose();
  }

  //=================================================================
}

class MedarbejderAfgaaet_WindowClosing extends WindowAdapter
{
  MedarbejderAfgaaetDialog   adaptee;
  MedarbejderAfgaaet_WindowClosing(MedarbejderAfgaaetDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void windowClosing(WindowEvent e)
  { adaptee.closeWindow ();  }
}

class MedarbejderAfgaaet_knapAfgaaet_actionAdapter implements java.awt.event.ActionListener
{
  MedarbejderAfgaaetDialog   adaptee;
  MedarbejderAfgaaet_knapAfgaaet_actionAdapter(MedarbejderAfgaaetDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.medarbejderAfgaaet();  }
}
class MedarbejderAfgaaet_knapRetur_actionAdapter implements java.awt.event.ActionListener
{
  MedarbejderAfgaaetDialog   adaptee;
  MedarbejderAfgaaet_knapRetur_actionAdapter(MedarbejderAfgaaetDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.closeWindow();  }
}


