package projektsystemGUI;
import projektsystemFunktioner.*;
import projektsystemKerne.*;
import bjbupack.util.Convert;
import bjbupack.gui.SelectDialog;
import java.awt.*;
import java.awt.event.*;
import java.util.Iterator;
import java.util.Date;
import java.sql.*;  
import java.awt.Rectangle;
import java.awt.Dimension;
/**  
  * GUI-Klassen til oprettelse af medarbejder
  * @version  Februar 2003
  * @author   Bjrk Boye Busch  
*/  


public  class MedarbejderOpretDialog extends Dialog
{
  private Frame    owner;

  private Medarbejder    medarbejder;       // aktuel udvalgt model-objekt
  private Postdistrikt   postdistrikt;      // aktuel udvalgt model-objekt

  private Button       knapAdd     = new Button     ();
  private Button       knapClear   = new Button     ();
  private Button       knapReturn  = new Button     ();
  private Button       knapPostdistrikt  = new Button     ();
  private Button       knapAddPostdistrikt  = new Button     ();
  private TextArea     events      = new TextArea   ();

  private Label         labelFornavn         = new Label ();
  private TextField     fornavn              = new TextField ();
  private Label         labelEfternavn       = new Label ();
  private TextField     efternavn            = new TextField ();
  private Label         labelGade            = new Label ();
  private TextField     gade                 = new TextField ();
  private Label         labelPostnr          = new Label ();
  private TextField     postnr               = new TextField ();
  private Label         labelDistrikt        = new Label ();
  private TextField     distrikt             = new TextField ();
  private Label         labelTlf             = new Label ();
  private TextField     tlf                  = new TextField ();
  private Label         labelAnsatDato       = new Label ();
  private TextField     ansatDato            = new TextField ();


  public MedarbejderOpretDialog (Frame ownerFrame)
  {
    super(ownerFrame, true/*modal*/);
    this.owner = ownerFrame;
    try
    {
      jbInit();
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }
  public void jbInit ()  throws Exception
  {
    this.setLayout(null);
    this.setSize(new Dimension(481, 396));
    this.setTitle("Medarbejder oprettelse");
  
    knapAdd.setLabel("Opret");
    knapAdd.setBounds(new Rectangle(350, 30, 110, 25));
    knapClear.setLabel("Blank");
    knapClear.setBounds(new Rectangle(350, 60, 110, 25));
    knapPostdistrikt.setLabel("Postdistrikt");
    knapPostdistrikt.setBounds(new Rectangle(350, 105, 110, 25));
    knapAddPostdistrikt.setLabel("Nyt postdistrikt");
    knapAddPostdistrikt.setBounds(new Rectangle(350, 135, 110, 25));
    knapReturn.setLabel("Retur");
    knapReturn.setBounds(new Rectangle(350, 175, 110, 25));
    events.setBounds(new Rectangle(10, 210, 455, 150));


    labelFornavn.setText("Fornavn:");
    labelFornavn.setBounds(new Rectangle(10, 30, 60, 20));
    fornavn.setBounds(new Rectangle(80, 30, 250, 20));
    labelEfternavn.setText("Efternavn:");
    labelEfternavn.setBounds(new Rectangle(10, 55, 60, 20));
    efternavn.setBounds(new Rectangle(80, 55, 250, 20));
    labelGade.setText("Gade:");
    labelGade.setBounds(new Rectangle(10, 80, 65, 20));
    gade.setBounds(new Rectangle(80, 80, 250, 20));
    labelPostnr.setText("Postnr:");
    labelPostnr.setBounds(new Rectangle(10, 105, 60, 20));
    postnr.setBounds(new Rectangle(80, 105, 40, 20));
    labelDistrikt.setText("By:");
    labelDistrikt.setBounds(new Rectangle(125, 105, 20, 20));
    distrikt.setBounds(new Rectangle(150, 105, 180, 20));
    labelTlf.setText("Tlf:");
    labelTlf.setBounds(new Rectangle(10, 130, 50, 15));
    tlf.setBounds(new Rectangle(80, 130, 55, 20));
    labelAnsatDato.setText("Ansat dato:");
    labelAnsatDato.setBounds(new Rectangle(10, 155, 65, 15));
    ansatDato.setBounds(new Rectangle(80, 155, 75, 20));

    this.add(labelFornavn, null);
    this.add(fornavn, null);
    this.add(labelEfternavn, null);
    this.add(efternavn, null);
    this.add(labelGade, null);
    this.add(gade, null);
    this.add(labelPostnr, null);
    this.add(postnr, null);
    this.add(labelDistrikt, null);
    this.add(distrikt, null);
    this.add(labelTlf, null);
    this.add(tlf, null);
    this.add(labelAnsatDato, null);
    this.add(ansatDato, null);
    this.add(knapAdd);
    this.add(knapClear);
    this.add(knapPostdistrikt);
    this.add(knapAddPostdistrikt);
    this.add(knapReturn);
    this.add(events);
  
    events.setEnabled(false);
    events.setRows(8);
    events.setColumns(90);

    this.addWindowListener ( new MedarbejderOpret_WindowClosing(this) );
    knapAdd.addActionListener(new MedarbejderOpret_knapAdd_Action(this));
    knapClear.addActionListener(new MedarbejderOpret_knapClear_Action(this));
    knapPostdistrikt.addActionListener(new MedarbejderOpret_knapPostdistrikt_Action(this));
    knapAddPostdistrikt.addActionListener(new MedarbejderOpret_knapAddPostdistrikt_Action(this));
    knapReturn.addActionListener(new MedarbejderOpret_knapReturn_Action(this));

    ansatDato.setText((new Timestamp((new Date()).getTime())).toString().substring(0,19));

    knapAdd.setEnabled(false);
    postnr.setEnabled(false);
    distrikt.setEnabled(false);
  }
  
  //=================================================================
  public void clearScreen ()
  {
    medarbejder = null;
    this.fornavn.setText("");
    this.efternavn.setText("");
    this.gade.setText("");
    this.postnr.setText("");
    this.distrikt.setText("");
    this.tlf.setText("");
    ansatDato.setText((new Timestamp((new Date()).getTime())).toString().substring(0,19));
  }
  
  public void addMedarbejder ()
  {
    try
    {
      medarbejder = GlobalModel.getProjektsystem().opretMedarbejder(fornavn.getText(),
                                     efternavn.getText(),
                                     gade.getText(),
                                     tlf.getText(),
                                     Timestamp.valueOf(ansatDato.getText()),
                                     postdistrikt);
      if (medarbejder != null)
      {
        events.append(medarbejder.toString());
        events.append(": oprettet\n");
      }
      else
        events.append(": Fejl ved oprettelse\n");
    }
    catch (Exception e)
    {
      events.append(": Fejl i inddate ved oprettelse:\n");
    }
  }

  public void selectPostdistrikt ()
  {
    Iterator  iterator = GlobalModel.getProjektsystem().getPostdistriktIterator();
    SelectDialog  selectDialog = new SelectDialog(this.owner,"Postdistrikt",true,iterator,15,true);
    selectDialog.setSize(600,400);
    selectDialog.setVisible(true);

    Object[]  ov  =  selectDialog.getSelectedObjects();
    if ((ov!=null)&&(ov.length>0))
      postdistrikt = (Postdistrikt)ov[0];
    if (postdistrikt == null)
    {
      this.postnr.setText("");
      this.distrikt.setText("");
      knapAdd.setEnabled(false);
    }
    else
    {
      this.postnr.setText(""+postdistrikt.getPostnr());
      this.distrikt.setText(""+postdistrikt.getDistrikt());
      knapAdd.setEnabled(true);
    }
  }

  public void addPostdistrikt ()
  {
    PostdistriktOpretDialog  postdistriktOpretDialog = new PostdistriktOpretDialog(this.owner);
    postdistriktOpretDialog.setVisible(true);
    postdistrikt = postdistriktOpretDialog.getPostdistrikt();
    if (postdistrikt == null)
    {
      this.postnr.setText("");
      this.distrikt.setText("");
      knapAdd.setEnabled(false);
    }
    else
    {
      this.postnr.setText(""+postdistrikt.getPostnr());
      this.distrikt.setText(""+postdistrikt.getDistrikt());
      knapAdd.setEnabled(true);
    }
  }
  
  public Medarbejder getMedarbejder()
  { return medarbejder;  }

  public void closeWindow ()
  {
     this.dispose();
  }
  
  //=================================================================
}

class MedarbejderOpret_WindowClosing extends WindowAdapter
{
  MedarbejderOpretDialog   adaptee;
  MedarbejderOpret_WindowClosing(MedarbejderOpretDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void windowClosing(WindowEvent e)
  { adaptee.closeWindow ();  }
}


class MedarbejderOpret_knapAdd_Action implements java.awt.event.ActionListener
{
  MedarbejderOpretDialog   adaptee;
  MedarbejderOpret_knapAdd_Action(MedarbejderOpretDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.addMedarbejder();  }
}

class MedarbejderOpret_knapClear_Action implements java.awt.event.ActionListener
{
  MedarbejderOpretDialog   adaptee;
  MedarbejderOpret_knapClear_Action(MedarbejderOpretDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.clearScreen();  }
}

class MedarbejderOpret_knapPostdistrikt_Action implements java.awt.event.ActionListener
{
  MedarbejderOpretDialog   adaptee;
  MedarbejderOpret_knapPostdistrikt_Action(MedarbejderOpretDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.selectPostdistrikt();  }
}

class MedarbejderOpret_knapAddPostdistrikt_Action implements java.awt.event.ActionListener
{
  MedarbejderOpretDialog   adaptee;
  MedarbejderOpret_knapAddPostdistrikt_Action(MedarbejderOpretDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.addPostdistrikt();  }
}

class MedarbejderOpret_knapReturn_Action implements java.awt.event.ActionListener
{
  MedarbejderOpretDialog   adaptee;
  MedarbejderOpret_knapReturn_Action(MedarbejderOpretDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.closeWindow();  }
}
