package projektsystemGUI;
import projektsystemFunktioner.*;
import projektsystemKerne.*;
import bjbupack.util.Convert;
import bjbupack.gui.SelectDialog;
import java.awt.*;
import java.awt.event.*;
import java.util.Iterator;
import java.sql.*;  
import java.awt.Rectangle;
import java.awt.Dimension;
/**
  * GUI-Klassen til at rette stamdata for Medarbejder
  * @version  Februar 2003
  * @author   Bjrk Boye Busch  
*/  

public  class MedarbejderRetStamdataDialog extends Dialog
{
  private Frame    owner;

  private Medarbejder    medarbejder;     // aktuel model-objekt
  private Postdistrikt   postdistrikt;     // aktuel model-objekt

  private Button       knapReplace = new Button     ();
  private Button       knapPostdistrikt = new Button     ();
  private Button       knapAddPostdistrikt = new Button     ();
  private Button       knapRetur   = new Button     ();

  private Label         labelFornavn         = new Label ();
  private TextField     fornavn              = new TextField ();
  private Label         labelEfternavn       = new Label ();
  private TextField     efternavn            = new TextField ();
  private Label         labelGade            = new Label ();
  private TextField     gade                 = new TextField ();
  private Label         labelPostnr          = new Label ();
  private TextField     postnr               = new TextField ();
  private Label         labelDistrikt        = new Label ();
  private TextField     distrikt             = new TextField ();
  private Label         labelTlf             = new Label ();
  private TextField     tlf                  = new TextField ();


    public MedarbejderRetStamdataDialog (Frame ownerFrame, Medarbejder medarbejder)
    {
      super(ownerFrame, true/*modal*/);
      this.owner = ownerFrame;
      this.medarbejder = medarbejder;
    try
    {
      jbInit();
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }
  public void jbInit ()  throws Exception
  {
    this.setSize(new Dimension(523, 221));
    this.setTitle("ndring af medarbejder stamdata");

    this.setLayout(null);
  
    knapReplace.setLabel("Opdatering");
    knapReplace.setBounds(new Rectangle(395, 40, 100, 25));
    knapPostdistrikt.setLabel("Postdistrikt");
    knapPostdistrikt.setBounds(new Rectangle(395, 115, 100, 25));
    knapAddPostdistrikt.setLabel("Nyt postdistrikt");
    knapAddPostdistrikt.setBounds(new Rectangle(395, 145, 100, 25));
    knapRetur.setLabel("Fortryd");
    knapRetur.setBounds(new Rectangle(395, 70, 100, 25));

    labelFornavn.setText("Fornavn:");
    labelFornavn.setBounds(new Rectangle(10, 45, 60, 20));
    fornavn.setBounds(new Rectangle(80, 45, 275, 20));
    labelEfternavn.setText("Efternavn:");
    labelEfternavn.setBounds(new Rectangle(10, 70, 60, 20));
    efternavn.setBounds(new Rectangle(80, 70, 275, 20));
    labelGade.setText("Gade:");
    labelGade.setBounds(new Rectangle(10, 95, 65, 20));
    gade.setBounds(new Rectangle(80, 95, 275, 20));
    labelPostnr.setText("Postnr:");
    labelPostnr.setBounds(new Rectangle(10, 120, 60, 20));
    postnr.setBounds(new Rectangle(80, 120, 40, 20));
    labelDistrikt.setText("By:");
    labelDistrikt.setBounds(new Rectangle(130, 120, 25, 20));
    distrikt.setBounds(new Rectangle(155, 120, 200, 20));
    labelTlf.setText("Tlf:");
    labelTlf.setBounds(new Rectangle(10, 145, 50, 15));
    tlf.setBounds(new Rectangle(80, 145, 55, 20));

    this.add(labelFornavn, null);
    this.add(fornavn, null);
    this.add(labelEfternavn, null);
    this.add(efternavn, null);
    this.add(labelGade, null);
    this.add(gade, null);
    this.add(labelPostnr, null);
    this.add(postnr, null);
    this.add(labelDistrikt, null);
    this.add(distrikt, null);
    this.add(labelTlf, null);
    this.add(tlf, null);
    this.add(knapReplace);
    this.add(knapPostdistrikt);
    this.add(knapAddPostdistrikt);
    this.add(knapRetur);

    this.addWindowListener ( new MedarbejderRetStamdata_WindowClosing(this) );
    knapReplace.addActionListener(new MedarbejderRetStamdata_knapReplace_Action(this));
    knapPostdistrikt.addActionListener(new MedarbejderRetStamdata_knapPostdistrikt_Action(this));
    knapAddPostdistrikt.addActionListener(new MedarbejderRetStamdata_knapAddPostdistrikt_Action(this));
    knapRetur.addActionListener(new MedarbejderRetStamdata_knapRetur_Action(this));

    fornavn.setText(""+medarbejder.getFornavn());
    efternavn.setText(""+medarbejder.getEfternavn());
    gade.setText(""+medarbejder.getGade());
    tlf.setText(""+medarbejder.getTlf());
    
    postdistrikt = medarbejder.getPostdistrikt();
    postnr.setText(""+postdistrikt.getPostnr());
    distrikt.setText(""+postdistrikt.getDistrikt());
    postnr.setEnabled(false);
    distrikt.setEnabled(false);
  }
  
  //=================================================================
  
  public void replaceMedarbejder ()
  {
     medarbejder.retStamdata ( fornavn.getText(), efternavn.getText(),
                               gade.getText(), tlf.getText(),
                               postdistrikt );
    closeWindow();
  }
  
  public void closeWindow ()
  {
     this.dispose();
  }

  public void selectPostdistrikt ()
  {
    Iterator  iterator = GlobalModel.getProjektsystem().getPostdistriktIterator();
    SelectDialog  selectDialog = new SelectDialog(this.owner,"Postdistrikt",true,iterator,15,true);
    selectDialog.setSize(600,400);
    selectDialog.setVisible(true);

    Object[]  ov  =  selectDialog.getSelectedObjects();
    if ((ov!=null)&&(ov.length>0))
      postdistrikt = (Postdistrikt)ov[0];
    if (postdistrikt == null)
    {
      this.postnr.setText("");
      this.distrikt.setText("");
      knapReplace.setEnabled(false);
    }
    else
    {
      this.postnr.setText(""+postdistrikt.getPostnr());
      this.distrikt.setText(""+postdistrikt.getDistrikt());
      knapReplace.setEnabled(true);
    }
  }

  public void addPostdistrikt ()
  {
    PostdistriktOpretDialog  postdistriktOpretDialog = new PostdistriktOpretDialog(this.owner);
    postdistriktOpretDialog.setVisible(true);
    postdistrikt = postdistriktOpretDialog.getPostdistrikt();
    if (postdistrikt == null)
    {
      this.postnr.setText("");
      this.distrikt.setText("");
      knapReplace.setEnabled(false);
    }
    else
    {
      this.postnr.setText(""+postdistrikt.getPostnr());
      this.distrikt.setText(""+postdistrikt.getDistrikt());
      knapReplace.setEnabled(true);
    }
  }

  //=================================================================
}

class MedarbejderRetStamdata_WindowClosing extends WindowAdapter
{
  MedarbejderRetStamdataDialog   adaptee;
  MedarbejderRetStamdata_WindowClosing(MedarbejderRetStamdataDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void windowClosing(WindowEvent e)
  { adaptee.closeWindow ();  }
}

class MedarbejderRetStamdata_knapReplace_Action implements java.awt.event.ActionListener
{
  MedarbejderRetStamdataDialog   adaptee;
  MedarbejderRetStamdata_knapReplace_Action(MedarbejderRetStamdataDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.replaceMedarbejder();  }
}

class MedarbejderRetStamdata_knapPostdistrikt_Action implements java.awt.event.ActionListener
{
  MedarbejderRetStamdataDialog   adaptee;
  MedarbejderRetStamdata_knapPostdistrikt_Action(MedarbejderRetStamdataDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.selectPostdistrikt();  }
}

class MedarbejderRetStamdata_knapAddPostdistrikt_Action implements java.awt.event.ActionListener
{
  MedarbejderRetStamdataDialog   adaptee;
  MedarbejderRetStamdata_knapAddPostdistrikt_Action(MedarbejderRetStamdataDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.addPostdistrikt();  }
}

class MedarbejderRetStamdata_knapRetur_Action implements java.awt.event.ActionListener
{
  MedarbejderRetStamdataDialog   adaptee;
  MedarbejderRetStamdata_knapRetur_Action(MedarbejderRetStamdataDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.closeWindow();  }
}


