package projektsystemGUI;
import projektsystemFunktioner.*;
import projektsystemKerne.*;
import bjbupack.util.Convert;
import bjbupack.gui.SelectDialog;
import java.awt.*;
import java.awt.event.*;
import java.util.Iterator;
import java.sql.*;  
import java.awt.Rectangle;
import java.awt.Dimension;
/**  
  * GUI-Klassen til  Postdistriktadministration
  * @version  Februar 2003 (1.15)
  * @author   ObjectGenerator  
*/  

public  class PostdistriktAdmDialog extends Dialog
{
  private Frame        ownerFrame;

  private Postdistrikt  postdistrikt;

  private Button       knapSelect  = new Button     ();
  private Button       knapReplace = new Button     ();
  private Button       knapAdd     = new Button     ();
  private Button       knapRemove  = new Button     ();
  private Button       knapReturn  = new Button     ();

  private Label         labelPostnr          = new Label ();
  private TextField     postnr               = new TextField ();
  private Label         labelDistrikt        = new Label ();
  private TextField     distrikt             = new TextField ();


  public PostdistriktAdmDialog (Frame ownerFrame)
  {
    super(ownerFrame, true/*modal*/);
    this.ownerFrame = ownerFrame;
    try
    {
      jbInit();
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }
  public void jbInit ()  throws Exception
  {

    this.setSize(new Dimension(447, 253));
    this.setTitle("Postdistrikt");


    this.setLayout(null);

    knapSelect.setLabel("Vlg postdistrikt");
    knapSelect.setBounds(new Rectangle(290, 40, 140, 25));
    knapAdd.setLabel("Opret postdistrikt");
    knapAdd.setBounds(new Rectangle(290, 70, 140, 25));
    knapReplace.setLabel("Ret postdistrikt");
    knapReplace.setBounds(new Rectangle(290, 115, 140, 25));
    knapRemove.setLabel("Slet postdistrikt");
    knapRemove.setBounds(new Rectangle(290, 145, 140, 25));
    knapReturn.setLabel("Retur");
    knapReturn.setBounds(new Rectangle(290, 190, 140, 25));

    labelPostnr.setText("Postnr:");
    labelPostnr.setBounds(new Rectangle(15, 50, 45, 15));
    labelDistrikt.setText("Distrikt:");
    labelDistrikt.setBounds(new Rectangle(15, 75, 55, 15));
    postnr.setBounds(new Rectangle(75, 45, 40, 20));
    postnr.setEnabled(false);
    distrikt.setBounds(new Rectangle(75, 70, 180, 20));

    this.add(knapSelect);
    this.add(knapReplace);
    this.add(knapAdd);
    this.add(knapRemove);
    this.add(knapReturn);
    this.add(labelPostnr, null);
    this.add(postnr, null);
    this.add(labelDistrikt, null);
    this.add(distrikt, null);


    this.addWindowListener ( new PostdistriktAdm_WindowClosing(this) );
    knapSelect.addActionListener(new PostdistriktAdm_knapSelect_Action(this));
    knapReplace.addActionListener(new PostdistriktAdm_knapReplace_Action(this));
    knapAdd.addActionListener(new PostdistriktAdm_knapAdd_Action(this));
    knapRemove.addActionListener(new PostdistriktAdm_knapRemove_Action(this));
    knapReturn.addActionListener(new PostdistriktAdm_knapReturn_Action(this));

    postnr.setEnabled(false);
    distrikt.setEnabled(false);
    postdistriktToFrame ();
  }

  //=================================================================

  public void postdistriktToFrame ()
  {
    if (postdistrikt==null)
    {
      this.postnr.setText("");
      this.distrikt.setText("");
      knapReplace.setEnabled(false);
      knapRemove.setEnabled(false);
    }
    else
    {
      this.postnr.setText(""+postdistrikt.getPostnr());
      this.distrikt.setText(""+postdistrikt.getDistrikt());
      knapReplace.setEnabled(true);
      knapRemove.setEnabled(false);
    }
  }


  public void selectPostdistrikt ()
  {
/*
    FindPostdistriktDialog  findPostdistriktDialog = new FindPostdistriktDialog(this.ownerFrame);
    findPostdistriktDialog.setVisible(true);
    postdistrikt = findPostdistriktDialog.getPostdistrikt();
*/
    Iterator  iterator = GlobalModel.getProjektsystem().getPostdistriktIterator();
    SelectDialog  selectDialog = new SelectDialog(this.ownerFrame,"Postdistrikt",true,iterator,15,true);
    selectDialog.setSize(600,400);
    selectDialog.setVisible(true);

    Object[]  ov  =  selectDialog.getSelectedObjects();
    if ((ov!=null)&&(ov.length>0))
      postdistrikt = (Postdistrikt)ov[0];

    postdistriktToFrame ();
  }

  public void replacePostdistrikt ()
  {
    PostdistriktRetStamdataDialog  postdistriktRetStamdataDialog = new PostdistriktRetStamdataDialog(this.ownerFrame, this.postdistrikt);
    postdistriktRetStamdataDialog.setVisible(true);
    postdistriktToFrame ();
  }


  public void addPostdistrikt ()
  {
    PostdistriktOpretDialog  postdistriktOpretDialog = new PostdistriktOpretDialog(this.ownerFrame);
    postdistriktOpretDialog.setVisible(true);
    postdistrikt = postdistriktOpretDialog.getPostdistrikt();
    postdistriktToFrame ();
  }

  public void removePostdistrikt ()
  {
    // IKKE IMPLEMENTERET
  }


  public void closeWindow ()
  {
    this.dispose();
  }
}

//=================================================================

class PostdistriktAdm_WindowClosing extends WindowAdapter
{
  PostdistriktAdmDialog   adaptee;
  PostdistriktAdm_WindowClosing(PostdistriktAdmDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void windowClosing(WindowEvent e)
  { adaptee.closeWindow ();  }
}

class PostdistriktAdm_knapSelect_Action implements java.awt.event.ActionListener
{
  PostdistriktAdmDialog   adaptee;
  PostdistriktAdm_knapSelect_Action(PostdistriktAdmDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.selectPostdistrikt();  }
}

class PostdistriktAdm_knapReplace_Action implements java.awt.event.ActionListener
{
  PostdistriktAdmDialog   adaptee;
  PostdistriktAdm_knapReplace_Action(PostdistriktAdmDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.replacePostdistrikt();  }
}

class PostdistriktAdm_knapAdd_Action implements java.awt.event.ActionListener
{
  PostdistriktAdmDialog   adaptee;
  PostdistriktAdm_knapAdd_Action(PostdistriktAdmDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.addPostdistrikt();  }
}

class PostdistriktAdm_knapRemove_Action implements java.awt.event.ActionListener
{
  PostdistriktAdmDialog   adaptee;
  PostdistriktAdm_knapRemove_Action(PostdistriktAdmDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.removePostdistrikt();  }
}

class PostdistriktAdm_knapReturn_Action implements java.awt.event.ActionListener
{
  PostdistriktAdmDialog   adaptee;
  PostdistriktAdm_knapReturn_Action(PostdistriktAdmDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.closeWindow();  }
}

