package projektsystemGUI;
import projektsystemFunktioner.*;
import projektsystemKerne.*;
import bjbupack.util.Convert;
import java.awt.*;
import java.awt.event.*;
import java.util.Iterator;
import java.util.Date;
import java.sql.*;  
import java.awt.Rectangle;
import java.awt.Dimension;
/**  
  * GUI-Klassen til oprettelse af postdistrikt
  * @version  Februar 2003
  * @author   Bjrk Boye Busch  
*/


public  class PostdistriktOpretDialog extends Dialog
{
  private Frame    owner;

  private Postdistrikt   postdistrikt;      // aktuel udvalgt model-objekt

  private Button       knapAdd     = new Button     ();
  private Button       knapClear   = new Button     ();
  private Button       knapReturn  = new Button     ();
  private TextArea     events      = new TextArea   ();

  private Label         labelPostnr          = new Label ();
  private TextField     postnr               = new TextField ();
  private Label         labelDistrikt        = new Label ();
  private TextField     distrikt             = new TextField ();


  public PostdistriktOpretDialog (Frame ownerFrame)
  {
    super(ownerFrame, true/*modal*/);
    this.owner = ownerFrame;
    try
    {
      jbInit();
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }
  public void jbInit ()  throws Exception
  {
    this.setLayout(null);
    this.setSize(new Dimension(395, 319));
    this.setTitle("Postdistrikt oprettelse");
  
    knapAdd.setLabel("Opret");
    knapAdd.setBounds(new Rectangle(285, 30, 90, 25));
    knapClear.setLabel("Blank");
    knapClear.setBounds(new Rectangle(285, 60, 90, 25));
    knapReturn.setLabel("Retur");
    knapReturn.setBounds(new Rectangle(285, 100, 90, 25));
    events.setBounds(new Rectangle(10, 135, 370, 150));


    labelPostnr.setText("Postnr:");
    labelPostnr.setBounds(new Rectangle(10, 30, 60, 20));
    postnr.setBounds(new Rectangle(80, 30, 40, 20));
    labelDistrikt.setText("Distrikt:");
    labelDistrikt.setBounds(new Rectangle(10, 55, 45, 20));
    distrikt.setBounds(new Rectangle(80, 55, 180, 20));

    this.add(labelPostnr, null);
    this.add(postnr, null);
    this.add(labelDistrikt, null);
    this.add(distrikt, null);
    this.add(knapAdd);
    this.add(knapClear);
    this.add(knapReturn);
    this.add(events);
  
    events.setEnabled(false);
    events.setRows(8);
    events.setColumns(90);

    this.addWindowListener ( new PostdistriktOpret_WindowClosing(this) );
    knapAdd.addActionListener(new PostdistriktOpret_knapAdd_Action(this));
    knapClear.addActionListener(new PostdistriktOpret_knapClear_Action(this));
    knapReturn.addActionListener(new PostdistriktOpret_knapReturn_Action(this));

  }
  
  //=================================================================
  public void clearScreen ()
  {
    postdistrikt = null;
    this.postnr.setText("");
    this.distrikt.setText("");
  }
  
  public void addPostdistrikt ()
  {
    try
    {
      postdistrikt = GlobalModel.getProjektsystem().opretPostdistrikt( Convert.toInt(postnr.getText()),
                                                    distrikt.getText());
      if (postdistrikt != null)
      {
        events.append(postdistrikt.toString());
        events.append(": oprettet\n");
      }
      else
        events.append(": Fejl ved oprettelse\n");
    }
    catch (Exception e)
    {
      events.append(": Fejl i inddate ved oprettelse:\n");
    }
  }
  
  public Postdistrikt getPostdistrikt()
  { return postdistrikt;  }

  public void closeWindow ()
  {
     this.dispose();
  }
  
  //=================================================================
}

class PostdistriktOpret_WindowClosing extends WindowAdapter
{
  PostdistriktOpretDialog   adaptee;
  PostdistriktOpret_WindowClosing(PostdistriktOpretDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void windowClosing(WindowEvent e)
  { adaptee.closeWindow ();  }
}


class PostdistriktOpret_knapAdd_Action implements java.awt.event.ActionListener
{
  PostdistriktOpretDialog   adaptee;
  PostdistriktOpret_knapAdd_Action(PostdistriktOpretDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.addPostdistrikt();  }
}

class PostdistriktOpret_knapClear_Action implements java.awt.event.ActionListener
{
  PostdistriktOpretDialog   adaptee;
  PostdistriktOpret_knapClear_Action(PostdistriktOpretDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.clearScreen();  }
}
class PostdistriktOpret_knapReturn_Action implements java.awt.event.ActionListener
{
  PostdistriktOpretDialog   adaptee;
  PostdistriktOpret_knapReturn_Action(PostdistriktOpretDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.closeWindow();  }
}
