package projektsystemGUI;
import projektsystemFunktioner.*;
import projektsystemKerne.*;
import bjbupack.util.Convert;
import bjbupack.gui.SelectDialog;
import java.awt.*;
import java.awt.event.*;
import java.util.Iterator;
import java.sql.*;  
import java.awt.Rectangle;
import java.awt.Dimension;
/**
  * GUI-Klassen til at rette stamdata for Postdistrikt
  * @version  Februar 2003
  * @author   Bjrk Boye Busch
*/

public  class PostdistriktRetStamdataDialog extends Dialog
{
  private Frame    owner;

  private Postdistrikt   postdistrikt;     // aktuel model-objekt

  private Button       knapReplace = new Button     ();
  private Button       knapRetur   = new Button     ();

  private Label         labelPostnr          = new Label ();
  private TextField     postnr               = new TextField ();
  private Label         labelDistrikt        = new Label ();
  private TextField     distrikt             = new TextField ();


    public PostdistriktRetStamdataDialog (Frame ownerFrame, Postdistrikt postdistrikt)
    {
      super(ownerFrame, true/*modal*/);
      this.owner = ownerFrame;
      this.postdistrikt = postdistrikt;
    try
    {
      jbInit();
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }
  public void jbInit ()  throws Exception
  {
    this.setSize(new Dimension(506, 132));
    this.setTitle("ndring af postdistrikt stamdata");

    this.setLayout(null);
  
    knapReplace.setLabel("Opdatering");
    knapReplace.setBounds(new Rectangle(395, 40, 90, 25));
    knapRetur.setLabel("Fortryd");
    knapRetur.setBounds(new Rectangle(395, 75, 90, 25));

    labelPostnr.setText("Postnr:");
    labelPostnr.setBounds(new Rectangle(10, 45, 60, 20));
    postnr.setBounds(new Rectangle(80, 45, 40, 20));
    labelDistrikt.setText("Distrikt:");
    labelDistrikt.setBounds(new Rectangle(15, 70, 50, 20));
    distrikt.setBounds(new Rectangle(80, 70, 200, 20));
    this.add(labelPostnr, null);

    this.add(postnr, null);
    this.add(labelDistrikt, null);
    this.add(distrikt, null);
    this.add(knapReplace);
    this.add(knapRetur);

    this.addWindowListener ( new PostdistriktRetStamdata_WindowClosing(this) );
    knapReplace.addActionListener(new PostdistriktRetStamdata_knapReplace_actionAdapter(this));
    knapRetur.addActionListener(new PostdistriktRetStamdata_knapRetur_actionAdapter(this));

    postnr.setText(""+postdistrikt.getPostnr());
    distrikt.setText(""+postdistrikt.getDistrikt());

    postnr.setEnabled(false);
  }
  
  //=================================================================
  
  public void replacePostdistrikt ()
  {
     postdistrikt.retStamdata ( distrikt.getText() );
     closeWindow();
  }
  
  public void closeWindow ()
  {
     this.dispose();
  }

  //=================================================================
}

class PostdistriktRetStamdata_WindowClosing extends WindowAdapter
{
  PostdistriktRetStamdataDialog   adaptee;
  PostdistriktRetStamdata_WindowClosing(PostdistriktRetStamdataDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void windowClosing(WindowEvent e)
  { adaptee.closeWindow ();  }
}

class PostdistriktRetStamdata_knapReplace_actionAdapter implements java.awt.event.ActionListener
{
  PostdistriktRetStamdataDialog   adaptee;
  PostdistriktRetStamdata_knapReplace_actionAdapter(PostdistriktRetStamdataDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.replacePostdistrikt();  }
}
class PostdistriktRetStamdata_knapRetur_actionAdapter implements java.awt.event.ActionListener
{
  PostdistriktRetStamdataDialog   adaptee;
  PostdistriktRetStamdata_knapRetur_actionAdapter(PostdistriktRetStamdataDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.closeWindow();  }
}


