package projektsystemGUI;
import projektsystemFunktioner.*;
import projektsystemKerne.*;
import bjbupack.util.Convert;
import java.awt.*;
import java.awt.event.*;
import java.util.Iterator;
import java.util.Date;
import java.sql.*;  
import java.awt.Rectangle;
import java.awt.Dimension;
/**
  * GUI-Klassen til oprettelse af projekt
  * @version  Februar 2003
  * @author   Bjrk Boye Busch
*/


public  class ProjektOpretDialog extends Dialog
{
  private Frame    owner;

  private Projekt   projekt;      // aktuel udvalgt model-objekt

  private Button       knapAdd     = new Button     ();
  private Button       knapClear   = new Button     ();
  private Button       knapReturn  = new Button     ();
  private TextArea     events      = new TextArea   ();

  private Label         labelBetegnelse      = new Label ();
  private TextField     betegnelse           = new TextField ();
  private Label         labelEtableringsDato = new Label ();
  private TextField     etableringsDato      = new TextField ();


  public ProjektOpretDialog (Frame ownerFrame)
  {
    super(ownerFrame, true/*modal*/);
    this.owner = ownerFrame;
    try
    {
      jbInit();
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }
  public void jbInit ()  throws Exception
  {
    this.setLayout(null);
    this.setSize(new Dimension(514, 319));
    this.setTitle("Projekt oprettelse");

    knapAdd.setLabel("Opret");
    knapAdd.setBounds(new Rectangle(405, 30, 90, 25));
    knapClear.setLabel("Blank");
    knapClear.setBounds(new Rectangle(405, 60, 90, 25));
    knapReturn.setLabel("Retur");
    knapReturn.setBounds(new Rectangle(405, 100, 90, 25));
    events.setBounds(new Rectangle(10, 135, 490, 150));


    labelBetegnelse.setText("Betegnelse:");
    labelBetegnelse.setBounds(new Rectangle(10, 30, 75, 20));
    betegnelse.setBounds(new Rectangle(110, 30, 280, 20));
    labelEtableringsDato.setText("EtableringsDato:");
    labelEtableringsDato.setBounds(new Rectangle(10, 55, 90, 20));
    etableringsDato.setBounds(new Rectangle(110, 55, 80, 20));

    this.add(labelBetegnelse, null);
    this.add(betegnelse, null);
    this.add(labelEtableringsDato, null);
    this.add(etableringsDato, null);
    this.add(knapAdd);
    this.add(knapClear);
    this.add(knapReturn);
    this.add(events);
  
    events.setEnabled(false);
    events.setRows(8);
    events.setColumns(90);

    this.addWindowListener ( new ProjektOpret_WindowClosing(this) );
    knapAdd.addActionListener(new ProjektOpret_knapAdd_Action(this));
    knapClear.addActionListener(new ProjektOpret_knapClear_Action(this));
    knapReturn.addActionListener(new ProjektOpret_knapReturn_Action(this));

    etableringsDato.setText((new Timestamp((new Date()).getTime())).toString().substring(0,19));
  }
  
  //=================================================================
  public void clearScreen ()
  {
    projekt = null;
    this.betegnelse.setText("");
    this.etableringsDato.setText("");
  }
  
  public void addProjekt ()
  {
    try
    {
      projekt = GlobalModel.getProjektsystem().opretProjekt( betegnelse.getText(),
                                          Timestamp.valueOf(etableringsDato.getText()));
      if (projekt != null)
      {
        events.append(projekt.toString());
        events.append(": oprettet\n");
      }
      else
        events.append(": Fejl ved oprettelse\n");
    }
    catch (Exception e)
    {
      events.append(": Fejl i inddate ved oprettelse:\n");
    }
  }
  
  public Projekt getProjekt()
  { return projekt;  }

  public void closeWindow ()
  {
     this.dispose();
  }
  
  //=================================================================
}

class ProjektOpret_WindowClosing extends WindowAdapter
{
  ProjektOpretDialog   adaptee;
  ProjektOpret_WindowClosing(ProjektOpretDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void windowClosing(WindowEvent e)
  { adaptee.closeWindow ();  }
}


class ProjektOpret_knapAdd_Action implements java.awt.event.ActionListener
{
  ProjektOpretDialog   adaptee;
  ProjektOpret_knapAdd_Action(ProjektOpretDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.addProjekt();  }
}

class ProjektOpret_knapClear_Action implements java.awt.event.ActionListener
{
  ProjektOpretDialog   adaptee;
  ProjektOpret_knapClear_Action(ProjektOpretDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.clearScreen();  }
}
class ProjektOpret_knapReturn_Action implements java.awt.event.ActionListener
{
  ProjektOpretDialog   adaptee;
  ProjektOpret_knapReturn_Action(ProjektOpretDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.closeWindow();  }
}
