package projektsystemGUI;
import projektsystemFunktioner.*;
import projektsystemKerne.*;
import bjbupack.util.Convert;
import bjbupack.gui.SelectDialog;
import java.awt.*;
import java.awt.event.*;
import java.util.Iterator;
import java.util.Vector;
import java.util.Date;
import java.sql.*;  
import bjbupack.gui.ObjectListBox;			// specialudgave af klassen List
import java.awt.Rectangle;
import java.awt.Dimension;
/**
  * GUI-Klassen til registrering af timeforbrug
  * @version  Februar 2003
  * @author   Bjrk Boye Busch
*/

public	class TimeforbrugOpretDialog extends Dialog
{

  private Aktivitet    aktivitet;

  private Frame        ownerFrame;

  private Button       knapAdd	   = new Button     ();
  private Button       knapFortryd  = new Button     ();


  private Label 	labelAktivitetBetegnelse = new Label ();
  private TextField	aktivitetBetegnelse	 = new TextField ();
  private Label 	labelMedarbejderNavn	 = new Label ();
  private TextField	medarbejderNavn 	 = new TextField ();
  private Label 	labelDato	     = new Label ();
  private TextField	dato		     = new TextField ();
  private Label 	labelTimer	     = new Label ();
  private TextField	timer		     = new TextField ();


  public TimeforbrugOpretDialog (Frame ownerFrame, Aktivitet aktivitet)
  {
    super(ownerFrame, true/*modal*/);
    this.ownerFrame = ownerFrame;
    this.aktivitet = aktivitet;       // gem tilhrende aktivitet
    try
    {
      jbInit();
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }
  public void jbInit ()  throws Exception
  {
    this.setSize(new Dimension(523, 354));
    this.setTitle("Registrering af timeforbrug");

    this.setLayout(null);

    knapAdd.setLabel("Registrer forbrug");
    knapAdd.setBounds(new Rectangle(375, 100, 125, 30));
    knapFortryd.setLabel("Fortryd");
    knapFortryd.setBounds(new Rectangle(375, 135, 125, 30));

    labelAktivitetBetegnelse.setText("Aktivitet:");
    labelAktivitetBetegnelse.setBounds(new Rectangle(10, 45, 65, 15));
    aktivitetBetegnelse.setEnabled(false);
    aktivitetBetegnelse.setBounds(new Rectangle(100, 45, 215, 20));

    labelMedarbejderNavn.setText("Medarbejder:");
    labelMedarbejderNavn.setBounds(new Rectangle(10, 70, 70, 15));
    medarbejderNavn.setEnabled(false);
    medarbejderNavn.setBounds(new Rectangle(100, 70, 215, 20));

    labelDato.setText("Dato:");
    labelDato.setBounds(new Rectangle(10, 130, 55, 15));
    dato.setBounds(new Rectangle(100, 130, 75, 20));

    labelTimer.setText("Timer:");
    labelTimer.setBounds(new Rectangle(10, 105, 70, 20));
    timer.setBounds(new Rectangle(100, 105, 75, 20));

    this.add(labelMedarbejderNavn, null);
    this.add(medarbejderNavn, null);
    this.add(labelAktivitetBetegnelse, null);
    this.add(aktivitetBetegnelse, null);
    this.add(labelTimer, null);
    this.add(timer, null);
    this.add(labelDato, null);
    this.add(dato, null);
    this.add(knapAdd);
    this.add(knapFortryd);
  

    this.addWindowListener ( new OpretTimeforbrug_WindowClosing(this) );
    knapAdd.addActionListener(new OpretTimeforbrug_knapAdd_Action(this));
    knapFortryd.addActionListener(new OpretTimeforbrug_knapFortryd_Action(this));

    dato.setText((new Timestamp((new Date()).getTime())).toString().substring(0,19));

    Medarbejder medarbejder = aktivitet.getMedarbejder();
    medarbejderNavn.setText(medarbejder.getFornavn()+" "+medarbejder.getEfternavn());
    aktivitetBetegnelse.setText(aktivitet.getBetegnelse());    
  }

  //=================================================================

  public void addTimeforbrug ()
  {
    Timeforbrug  timeforbrug	= aktivitet.opretTimeforbrug (
                                Timestamp.valueOf(dato.getText()),
                                Convert.toFloat(timer.getText()) );

    closeWindow();
  }

  public void afslutTimeforbrug ()
  {
    closeWindow();
  }

  public void closeWindow ()
  {
     this.dispose();
  }

  //=================================================================
}

class OpretTimeforbrug_WindowClosing extends WindowAdapter
{
  TimeforbrugOpretDialog   adaptee;
  OpretTimeforbrug_WindowClosing(TimeforbrugOpretDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void windowClosing(WindowEvent e)
  { adaptee.closeWindow ();  }
}

class OpretTimeforbrug_knapAdd_Action implements java.awt.event.ActionListener
{
  TimeforbrugOpretDialog   adaptee;
  OpretTimeforbrug_knapAdd_Action(TimeforbrugOpretDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.addTimeforbrug();	}
}

class OpretTimeforbrug_knapFortryd_Action implements java.awt.event.ActionListener
{
  TimeforbrugOpretDialog   adaptee;
  OpretTimeforbrug_knapFortryd_Action(TimeforbrugOpretDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.afslutTimeforbrug();  }
}



