package projektsystemKerne;
import java.util.*;  
import java.sql.*;  
/**  
  * @version  Januar 2002 (1.10)
  * @author   ObjectGenerator  
  * tilrettet af Bjrk Busch februar 2003 / januar 2004
*/  

public class Aktivitet 
{  
  public  static  int      TILSTAND_AKTIV = 0;
  public  static  int      TILSTAND_FAERDIG = 1;

  private   int            iD;
  private   String         betegnelse;
  private   Timestamp      tildeltDato;
  private   Timestamp      faerdigDato;
  private   int            tilstand;
  private   int            medarbejderID;
  private   int            projektID;


  // Constructor til at  genetablere eksisterende object
  public   Aktivitet ( int            iD,
                       String         betegnelse,
                       Timestamp      tildeltDato,
                       Timestamp      faerdigDato,
                       int            tilstand,
                       int            medarbejderID,
                       int            projektID )
  {
    this.iD = iD;
    this.betegnelse = betegnelse;
    if (tildeltDato == null) this.tildeltDato = null;
    else this.tildeltDato = (Timestamp)tildeltDato.clone();
    if (faerdigDato == null) this.faerdigDato = null;
    else this.faerdigDato = (Timestamp)faerdigDato.clone();
    this.tilstand = tilstand;
    this.medarbejderID = medarbejderID;
    this.projektID = projektID;
  }

   //------- getmetoder
  protected   int   getID ( )
  {  return this.iD;   }
  public   String   getBetegnelse ( )
  {  return this.betegnelse;   }
  public   Timestamp   getTildeltDato ( )
  {
    if (this.tildeltDato == null) return null;
    return (Timestamp)this.tildeltDato.clone();
  }
  public   Timestamp   getFaerdigDato ( )
  {
    if (this.faerdigDato == null) return null;
    return (Timestamp)this.faerdigDato.clone();
  }
  public   int   getTilstand ( )
  {  return this.tilstand;   }
  protected   int   getMedarbejderID ( )      // rettet til protected
  {  return this.medarbejderID;   }
  protected   int   getProjektID ( )          // rettet til protected
  {  return this.projektID;   }

  public    String   toString()
  {
    return (""+ getBetegnelse ( )
            + ","+ getTildeltDato ( )
            + ","+ getFaerdigDato ( )
            + ","+ getTilstand ( )
            );
  }

  //------- ekstra metoder
  // Tilgang til Medarbejder-collection controler
  private  static  MedarbejderAdministrator  getMedarbejderAdministrator()
  {    return (PersistensAdministrator.getMedarbejderAdministrator());  }

  // Tilgang til Projekt-collection controler
  private  static  ProjektAdministrator  getProjektAdministrator()
  {    return (PersistensAdministrator.getProjektAdministrator());  }

  // Tilgang til Aktivitet-collection controler
  private  static  AktivitetAdministrator  getAktivitetAdministrator()
  {    return (PersistensAdministrator.getAktivitetAdministrator());  }

  // Tilgang til Timeforbrug-collection controler
  private  static  TimeforbrugAdministrator  getTimeforbrugAdministrator()
  {    return (PersistensAdministrator.getTimeforbrugAdministrator());  }

 // Constructor til at oprette objekt
  public   Aktivitet ( int            iD,
                       String         betegnelse,
                       Timestamp      tildeltDato,
                       Medarbejder    medarbejder,
                       Projekt        projekt )
  {
    this.iD = iD;
    this.betegnelse = betegnelse;
    this.tildeltDato = tildeltDato;
    this.tilstand = TILSTAND_AKTIV;
    this.medarbejderID = medarbejder.getID();
    this.projektID = projekt.getID();
  }

  public   void   retStamdata (String betegnelse)
  {
    this.betegnelse = betegnelse;
    ProjektAdministrator projektAdm = getProjektAdministrator();
    projektAdm.replace(this);
 }
  
  public   Timeforbrug   opretTimeforbrug ( Timestamp dato, float timer )
  { 
    TimeforbrugAdministrator  timeforbrugAdm = getTimeforbrugAdministrator();
    Timeforbrug timeforbrug = timeforbrugAdm.newTimeforbrug(dato, timer, this);
    timeforbrugAdm.add(timeforbrug);
    return timeforbrug;
  }

  public   Iterator   getTimeforbrugIterator ()
  {
    TimeforbrugAdministrator  timeforbrugAdm = getTimeforbrugAdministrator();
    return timeforbrugAdm.iterator(this);
  }

  public   Medarbejder   getMedarbejder ( )
  {  
    MedarbejderAdministrator medarbejderAdm = getMedarbejderAdministrator();
    return (Medarbejder)medarbejderAdm.get(medarbejderID);
  }

  public   Projekt   getProjekt ( )
  {
    ProjektAdministrator projektAdm = getProjektAdministrator();
    return (Projekt)projektAdm.get(projektID);
  }

  // registrering af projekt frdigmeldt
  public   void   faerdigmeld (Timestamp faerdigDato)
  {  
    this.faerdigDato = (Timestamp)faerdigDato.clone();
    this.tilstand = TILSTAND_FAERDIG;
    ProjektAdministrator projektAdm = getProjektAdministrator();
    projektAdm.replace(this);
  }

}  