package projektsystemKerne;
import java.util.*;  
import java.sql.*;  
/**  
  * @version  Januar 2002 (1.10)
  * @author   ObjectGenerator  
  * tilrettet af Bjrk Busch februar 2003 / januar 2004
*/  

public class Projekt
{  
  public  static  int      TILSTAND_AKTIV = 0;
  public  static  int      TILSTAND_FAERDIG = 1;

  private   int            iD;
  private   String         betegnelse;
  private   Timestamp      etableringsDato;
  private   Timestamp      faerdigDato;
  private   int            tilstand;


  // Constructor til at genetablere eksisterende object
  public   Projekt ( int            iD,
                     String         betegnelse,
                     Timestamp      etableringsDato,
                     Timestamp      faerdigDato,
                     int            tilstand )
  {
    this.iD = iD;
    this.betegnelse = betegnelse;
    if (etableringsDato == null) this.etableringsDato = null;
    else this.etableringsDato = (Timestamp)etableringsDato.clone();
    if (faerdigDato == null) this.faerdigDato = null;
    else this.faerdigDato = (Timestamp)faerdigDato.clone();
    this.tilstand = tilstand;
  }

  //------- getmetoder
  protected   int   getID ( )
  {  return this.iD;   }
  public   String   getBetegnelse ( )
  {  return this.betegnelse;   }
  public   Timestamp   getEtableringsDato ( )
  {
    if (this.etableringsDato == null) return null;
    return (Timestamp)this.etableringsDato.clone();
  }
  public   Timestamp   getFaerdigDato ( )
  {
    if (this.faerdigDato == null) return null;
    return (Timestamp)this.faerdigDato.clone();
  }
  public   int   getTilstand ( )
  {  return this.tilstand;   }

  public    String   toString()
  {
    return (""+ getBetegnelse ( )
            + ","+ getEtableringsDato ( )
            + ","+ getFaerdigDato ( )
            + ","+ getTilstand ( )
            );
  }

  //------- ekstra metoder
  // Tilgang til Projekt-collection controler
  private  static  ProjektAdministrator  getProjektAdministrator()
  {    return (PersistensAdministrator.getProjektAdministrator());  }

  // Tilgang til Aktivitet-collection controler
  private  static  AktivitetAdministrator  getAktivitetAdministrator()
  {    return (PersistensAdministrator.getAktivitetAdministrator());  }

  // Constructor til at oprette object
  public   Projekt ( int            iD,
                     String         betegnelse,
                     Timestamp      etableringsDato )
  {
    this.iD = iD;
    this.betegnelse = betegnelse;
    this.etableringsDato = (Timestamp)etableringsDato.clone();
    this.tilstand = TILSTAND_AKTIV;
  }


  public   void   retStamdata (String betegnelse)
  {
    this.betegnelse = betegnelse;
    ProjektAdministrator projektAdm = getProjektAdministrator();
    projektAdm.replace(this);
 }

  
  // registrering af projekt frdigmeldt
  public   void   faerdigmeld (Timestamp faerdigDato)
  {  
    this.faerdigDato = (Timestamp)faerdigDato.clone();
    this.tilstand = TILSTAND_FAERDIG;
    ProjektAdministrator projektAdm = getProjektAdministrator();
    projektAdm.replace(this);
  }

  public   Aktivitet   opretAktivitet ( String betegnelse, Timestamp tildeltDato,
                                        Medarbejder medarbejder )
  { 
    AktivitetAdministrator aktivitetAdm = getAktivitetAdministrator();
    Aktivitet aktivitet = aktivitetAdm.newAktivitet(betegnelse,tildeltDato, medarbejder, this);
    aktivitetAdm.add(aktivitet);
    return aktivitet;
  }

  public   Iterator   getAktivitetIterator ()
  { 
    AktivitetAdministrator aktivitetAdm = getAktivitetAdministrator();
    return aktivitetAdm.iterator(this);
  }

}  
