package projektsystemKerne;
import bjbupack.jdb.*;  
import java.sql.*;  
import java.util.*;  
/**  
  * Klassen til hndtering af Projekt-Objekter i relationel database  
  * @version  Januar 2002 (1.10)
  * @author   DBObjectAdministratorGenerator  
*/  

public class ProjektAdministrator  extends DBObjectAdministrator  
{  
  private  int  lastKey   = 0;     // gemmer til autonummerering 
  public  ProjektAdministrator (DBAdministrator    dbAdministrator,   
                              String table)  
  {  
    super (dbAdministrator, table, "ID","SELECT * FROM "+table);  
    lastKey = getLastKey();    // gemmer til autonummerering  
  }  

  // get-metode med to ngler disables, da objekt er med enkeltngle
  public  Object  get (int key, int key2)
  {
    System.out.println("Fejl: der skal anvendes metode med eet nglerfelt");
    throw new UnsupportedOperationException();
  }

  // contains-metode som checkker om objekt med ngle findes
  public  boolean  contains ( Object object )  
  {  
    Projekt   projekt = (Projekt)object;  
    return get(projekt.getID()) != null;
  }

  // opretter et nyt object p databasen - implementer abstract  
  public  boolean  add ( Object object )
  {  
    Projekt   projekt = (Projekt)object;  
     
    String  SQL_EtableringsDato;
    if (projekt.getEtableringsDato() == null) SQL_EtableringsDato = "NULL";
    else SQL_EtableringsDato = "'"+projekt.getEtableringsDato().toString().substring(0,19)+"'";
    String  SQL_FaerdigDato;
    if (projekt.getFaerdigDato() == null) SQL_FaerdigDato = "NULL";
    else SQL_FaerdigDato = "'"+projekt.getFaerdigDato().toString().substring(0,19)+"'";
     
    String sql   = "INSERT INTO "+table  
                + " ("  
                + "  [ID]"  
                + "  ,[Betegnelse]"  
                + "  ,[EtableringsDato]"  
                + "  ,[FaerdigDato]"  
                + "  ,[Tilstand]"  
                + " ) VALUES "  
                + " ("  
                + "  "  +projekt.getID()      +""  
                + ", '"  +projekt.getBetegnelse()      +"'"  
                + ", "  +SQL_EtableringsDato
                + ", "  +SQL_FaerdigDato
                + ", "  +projekt.getTilstand()      +""  
                + " )";  
    return ( executeUpdate (sql) );  
  }  

  // opdaterer et eksisterede object p databasen - implementer abstract  
  public  boolean  replace ( Object object )  
  {  
    Projekt   projekt = (Projekt)object;  
     
    String  SQL_EtableringsDato;
    if (projekt.getEtableringsDato() == null) SQL_EtableringsDato = "NULL";
    else SQL_EtableringsDato = "'"+projekt.getEtableringsDato().toString().substring(0,19)+"'";
    String  SQL_FaerdigDato;
    if (projekt.getFaerdigDato() == null) SQL_FaerdigDato = "NULL";
    else SQL_FaerdigDato = "'"+projekt.getFaerdigDato().toString().substring(0,19)+"'";
     
    String sql  = "UPDATE "+table+" SET"  
                + "  [Betegnelse]='"  +projekt.getBetegnelse()    +"'"  
                + ", [EtableringsDato]="  +SQL_EtableringsDato
                + ", [FaerdigDato]="  +SQL_FaerdigDato
                + ", [Tilstand]="  +projekt.getTilstand()    +""  
                + " WHERE [ID]="  +projekt.getID()    +""  
                ;  
    return ( executeUpdate (sql) );  
  }  

  // sletter et object fra dabasen - implementer abstract  
  public  boolean  remove ( Object object )  
  {  
    Projekt   projekt = (Projekt)object;  
    String sql  = "DELETE * FROM "+table  
                + " WHERE [ID]="  +projekt.getID()    +""  
                ;  
    return ( executeUpdate (sql) );  
  }  

  // Konverter fra ResultSet til object - implementer abstract  
  protected  Object  convertToObject (ResultSet resultSet)  
  {  
    try  
    {  
      Projekt   projekt = new Projekt (   resultSet.getInt("ID"),  
                                   resultSet.getString("Betegnelse"),  
                                   resultSet.getTimestamp("EtableringsDato"),  
                                   resultSet.getTimestamp("FaerdigDato"),  
                                   resultSet.getInt("Tilstand")   ); 
      return (projekt);  
    }  
    catch (SQLException e)      
    {  
      System.out.println("Fejl ved convertToObject fra "+table);
      return (null);  
    }  
  }  

  // Ekstra metoder

  // returner et nyt object - skal gemmes p databasen med add  
  // metoden er tilrettet 
  public  Projekt  newProjekt ( String betegnelse, 
                                Timestamp etableringsDato )
  {  
    ++lastKey;  
    Projekt projekt = new Projekt ( lastKey,
                                    betegnelse, 
                                    etableringsDato );
    return (projekt);  
  }  

}  