package projektsystemKerne;
import java.sql.*;
import java.util.*;
/**
  * Klassen til hndtering af Projektsystem-Objekter
  * @version  Januar 2002, Januar 2004
  * @author   Bjrk Busch
*/

public class Projektsystem
{
  // Tilgang til Projekt-collection controler
  private  static  ProjektAdministrator  getProjektAdministrator()
  {    return (PersistensAdministrator.getProjektAdministrator());  }

  // Tilgang til Medarbejder-collection controler
  private  static  MedarbejderAdministrator  getMedarbejderAdministrator()
  {    return (PersistensAdministrator.getMedarbejderAdministrator());  }

  // Tilgang til Postdistrikt-collection controler
  private  static  PostdistriktAdministrator  getPostdistriktAdministrator()
  {  return (PersistensAdministrator.getPostdistriktAdministrator());  }


  public  Medarbejder  opretMedarbejder ( String         fornavn,
                                          String         efternavn,
                                          String         gade,
                                          String         tlf,
                                          Timestamp      ansatDato,
                                          Postdistrikt   postdistrikt )
  {
    Medarbejder  medarbejder  = getMedarbejderAdministrator().newMedarbejder (fornavn, efternavn, gade, tlf,
                                                                              ansatDato, postdistrikt);
    getMedarbejderAdministrator().add(medarbejder);
    return (medarbejder);
  }

  public  void  sletMedarbejder (Medarbejder medarbejder)
  {
    getMedarbejderAdministrator().remove(medarbejder);
  }

  public  Iterator  getMedarbejderIterator ()
  {
    return getMedarbejderAdministrator().iterator();
  }
  
  public  Projekt  opretProjekt ( String betegnelse, Timestamp etableringsDato )
  {
    Projekt  projekt  = getProjektAdministrator().newProjekt (betegnelse, etableringsDato);
    getProjektAdministrator().add(projekt);
    return (projekt);
  }

  public  void  sletProjekt (Projekt projekt)
  {
    getProjektAdministrator().remove(projekt);
  }

  public  Iterator  getProjektIterator ()
  {
    return getProjektAdministrator().iterator();
  }
  
  public  Postdistrikt  opretPostdistrikt ( int postnr, String distrikt )
  {
    Postdistrikt  postdistrikt  = getPostdistriktAdministrator().newPostdistrikt (postnr, distrikt);
    getPostdistriktAdministrator().add(postdistrikt);
    return (postdistrikt);
  }

  public  void  sletPostdistrikt (Postdistrikt postdistrikt)
  {
    getPostdistriktAdministrator().remove(postdistrikt);
  }

  public  Iterator  getPostdistriktIterator ()
  {
    return getPostdistriktAdministrator().iterator();
  }
}
