package projektsystemKerne;
import java.io.*;  
import java.util.*;  
import java.sql.*;  
/**  
  * @version  Januar 2002
  * @author   Bjrk Busch
*/  

public class Aktivitet implements Serializable
{  
  public  static  int      TILSTAND_AKTIV = 0;
  public  static  int      TILSTAND_FAERDIG = 1;

  private   String         betegnelse;
  private   Timestamp      tildeltDato;
  private   Timestamp      faerdigDato;
  private   int            tilstand;

  private   Medarbejder    medarbejder;
  private   Projekt        projekt;
  private   Collection     timeforbrugCollection = new Vector();


  // Constructor til at oprette object
  public   Aktivitet ( String         betegnelse,
                       Timestamp      tildeltDato,
                       Medarbejder    medarbejder,
                       Projekt        projekt )
  {
    this.betegnelse = betegnelse;
    this.tildeltDato = tildeltDato;
    this.tilstand = TILSTAND_AKTIV;
    this.medarbejder = medarbejder;
    this.medarbejder.connect(this);      // forbind i modsat retning
    this.projekt = projekt;
  }

  //------- getmetoder
  public   String   getBetegnelse ( )
  {  return (this.betegnelse);   }
  public   Timestamp   getTildeltDato ( )
  {
    if (this.tildeltDato == null) return null;
    return (Timestamp)this.tildeltDato.clone();
  }
  public   Timestamp   getFaerdigDato ( )
  {
    if (this.faerdigDato == null) return null;
    return (Timestamp)this.faerdigDato.clone();
  }
  public   int   getTilstand ( )
  {  return (this.tilstand);   }


  public    String   toString()
  {
    return ("" + getBetegnelse ( )
            + ","+ getTildeltDato ( )
            + ","+ getFaerdigDato ( )
            + ","+ getTilstand ( )
            );
  }

  //------- ekstra metoder
  public   void   retStamdata (String betegnelse)
  {  this.betegnelse = betegnelse;   }
  
  public   Timeforbrug   opretTimeforbrug ( Timestamp dato, float timer )
  { 
    Timeforbrug timeforbrug = new Timeforbrug(dato, timer);
    this.timeforbrugCollection.add(timeforbrug);
    return timeforbrug;
  }

  public   Iterator   getTimeforbrugIterator ()
  {  return timeforbrugCollection.iterator();   }

  public   Medarbejder   getMedarbejder ( )
  {  return (this.medarbejder);   }

  public   Projekt   getProjekt ( )
  {  return (this.projekt);   }

  // registrering af projekt frdigmeldt
  public   void   faerdigmeld (Timestamp faerdigDato)
  {  
    this.faerdigDato = (Timestamp)faerdigDato.clone();
    this.tilstand = TILSTAND_FAERDIG;
  }

}  