package projektsystemKerne;
import java.util.*;  
import java.sql.*;  
/**  
  * Klassen anvendes til at sikre global tilgang til ProjektsystemAdministrator og hermed modelkomponenten  
  * Klassen giver samtidig et singleton-mnster, der sikre at der kun er et objekt.
  * 
  * Klassen fungerer som controler overordnet for modelkomponenten.
  * 
  * @version  Januar 2002
  * @author   Bjrk Busch
*/  

public class GlobalModel
{
  // Overordnet persistens-controler og privat metode for tilgang
  private  static  Projektsystem  oneProjektsystem = new Projektsystem();

  public  static  Projektsystem  getProjektsystem ()
  {
    if (oneProjektsystem==null)       // opret tomt hvis ikke noget findes
      oneProjektsystem = new Projektsystem();
    return (oneProjektsystem);
  }

  // Anvendes til klargring af modelkomponenten
  public  static void  open ()
  {
    try
    { oneProjektsystem = (Projektsystem)FileManager.loadModel("data/","projektsystem.dat");  }
    catch (Exception  e)
    { System.out.println("Exception ved open");  }
  }
  // sikrer tilbageskrivning af modelkomponenten undervejs
  public  static void  save ()
  {
    try
//    { FileManager.saveModel("data/","projektsystem.dat",oneProjektsystem); }
    { FileManager.saveModel("data/","projektsystem.dat",oneProjektsystem); }
    catch (Exception  e)
    { System.out.println("Exception ved close"); }
  }
  // sikrer endelig tilbageskrivning af modelkomponenten
  public  static void  close ()
  {
    save();
  }

}
