package projektsystemKerne;
import java.io.*;  
import java.util.*;  
import java.sql.*;  
/**  
  * @version  Januar 2002 / Februar 2003
  * @author   Bjrk Busch
*/  

public class Medarbejder implements Serializable
{
  public  static  int      TILSTAND_ANSAT = 0;
  public  static  int      TILSTAND_AFGAAET = 1;
  public  static  int      AFGAAET_AARSAG_FYRET = 0;
  public  static  int      AFGAAET_AARSAG_SAGTOP = 1;

  private   String         fornavn;
  private   String         efternavn;
  private   String         gade;
  private   String         tlf;
  private   Timestamp      ansatDato;
  private   Timestamp      afgaaetDato;
  private   int            afgaaetAarsag;
  private   int            tilstand;

  private   Postdistrikt   postdistrikt;
  private   Collection     aktivitetCollection = new Vector();



  // Constructor til at oprette object
  public   Medarbejder ( String         fornavn,
                         String         efternavn,
                         String         gade,
                         String         tlf,
                         Timestamp      ansatDato,
                         Postdistrikt   postdistrikt )
  {
    this.fornavn = fornavn;
    this.efternavn = efternavn;
    this.gade = gade;
    this.tlf = tlf;
    this.ansatDato   = (Timestamp)ansatDato.clone();
    this.tilstand = TILSTAND_ANSAT;
    this.postdistrikt = postdistrikt;
  }

  //------- getmetoder
  public   String   getFornavn ( )
  {  return (this.fornavn);   }
  public   String   getEfternavn ( )
  {  return (this.efternavn);   }
  public   String   getGade ( )
  {  return (this.gade);   }
  public   String   getTlf ( )
  {  return (this.tlf);   }
  public   Timestamp   getAnsatDato ( )
  {
    if (this.ansatDato == null) return null;
    return (Timestamp)this.ansatDato.clone();
  }
  public   Timestamp   getAfgaaetDato ( )
  {
    if (this.afgaaetDato == null) return null;
    return (Timestamp)this.afgaaetDato.clone();
  }
  public   int   getAfgaaetAarsag()
  {  return this.afgaaetAarsag; }
  public   int   getTilstand ( )
  {  return (this.tilstand);   }

  public    String   toString()
  {
    return (""+ getFornavn ( )
            + ","+ getEfternavn ( )
            + ","+ getGade ( )
            + ","+ getTlf ( )
            + ","+ getAnsatDato ( )
            + ","+ getAfgaaetDato ( )
            + ","+ getTilstand ( )
            );
  }


  //------- ekstra metoder

  public   void   retStamdata ( String fornavn, String efternavn,
                                String gade, String tlf,
                                Postdistrikt   postdistrikt)
  {
    this.fornavn = fornavn;
    this.efternavn = efternavn;
    this.gade = gade;
    this.tlf = tlf;
    this.postdistrikt = postdistrikt;
  }

  public   void   connect (Aktivitet aktivitet)
  {  this.aktivitetCollection.add(aktivitet);   }

  public   void   disconnect (Aktivitet aktivitet)
  {  this.aktivitetCollection.remove(aktivitet);   }

  public   Iterator   getAktivitetIterator ()
  {  return aktivitetCollection.iterator();   }
  
  public   Postdistrikt   getPostdistrikt ( )
  {  return (this.postdistrikt);   }

  // registrering af medarbejder afget
  public   void   afgaaet (Timestamp dato, int aarsag)
  {  
    this.afgaaetDato   = (Timestamp)dato.clone();
    this.afgaaetAarsag = aarsag;
    this.tilstand      = TILSTAND_AFGAAET;
  }


}  
