package projektsystemKerne;
import java.io.*;  
import java.util.*;  
import java.sql.*;  
/**  
  * @version  Januar 2002
  * @author   Bjrk Busch
*/  

public class Projekt implements Serializable
{  
  public  static  int      TILSTAND_AKTIV = 0;
  public  static  int      TILSTAND_FAERDIG = 1;

  private   int            iD;
  private   String         betegnelse;
  private   Timestamp      etableringsDato;
  private   Timestamp      faerdigDato;
  private   int            tilstand;

  private   Collection     aktivitetCollection = new Vector();
  private   Collection     timeforbrugCollection = new Vector();


  // Constructor til at oprette object
  public   Projekt ( String         betegnelse,
                     Timestamp      etableringsDato )
  {
    this.betegnelse = betegnelse;
    this.etableringsDato = (Timestamp)etableringsDato.clone();
    this.tilstand = TILSTAND_AKTIV;
  }

  //------- getmetoder
  public   String   getBetegnelse ( )
  {  return (this.betegnelse);   }
  public   Timestamp   getEtableringsDato ( )
  {
    if (this.etableringsDato == null) return null;
    return (Timestamp)this.etableringsDato.clone();
  }
  public   Timestamp   getFaerdigDato ( )
  {
    if (this.faerdigDato == null) return null;
    return (Timestamp)this.faerdigDato.clone();
  }
  public   int   getTilstand ( )
  {  return (this.tilstand);   }

  public    String   toString()
  {
    return ("" + getBetegnelse ( )
            + ","+ getEtableringsDato ( )
            + ","+ getFaerdigDato ( )
            + ","+ getTilstand ( )
            );
  }

  //------- ekstra metoder

  public   void   retStamdata (String betegnelse)
  {  this.betegnelse = betegnelse;   }

  
  // registrering af projekt frdigmeldt
  public   void   faerdigmeld (Timestamp faerdigDato)
  {  
    this.faerdigDato = faerdigDato;
    this.tilstand = TILSTAND_FAERDIG;
  }

  public   Aktivitet   opretAktivitet ( String betegnelse, Timestamp tildeltDato,
                                        Medarbejder medarbejder )
  { 
    Aktivitet aktivitet = new Aktivitet(betegnelse,tildeltDato, medarbejder,this);
   this.aktivitetCollection.add(aktivitet);
   return aktivitet;
  }

  public   Iterator   getAktivitetIterator ()
  {  return aktivitetCollection.iterator();   }


}  