package projektsystemKerne;
import java.io.*;
import java.sql.*;
import java.util.*;
/**
  * Klassen til hndtering af Projektsystem-Objekter
  * @version  Januar 2002, Januar 2004
  * @author   Bjrk Busch
*/

public class Projektsystem implements Serializable
{
  private Collection   projektCollection = new Vector();
  private Collection   medarbejderCollection = new Vector();
  private Collection   postdistriktCollection = new Vector();

  public  Medarbejder  opretMedarbejder ( String         fornavn,
                                          String         efternavn,
                                          String         gade,
                                          String         tlf,
                                          Timestamp      ansatDato,
                                          Postdistrikt   postdistrikt )
  {
    Medarbejder  medarbejder  = new Medarbejder  (fornavn, efternavn, gade, tlf,
                                                  ansatDato, postdistrikt);
    medarbejderCollection.add(medarbejder);
    return medarbejder;
  }

  public  Iterator  getMedarbejderIterator ()
  {
    return medarbejderCollection.iterator();
  }
  
  public  Projekt  opretProjekt ( String betegnelse, Timestamp etableringsDato )
  {
    Projekt  projekt  = new Projekt  (betegnelse, etableringsDato);
    projektCollection.add(projekt);
    return projekt;
  }

  public  Iterator  getProjektIterator ()
  {
    return projektCollection.iterator();
  }
  
  public  Postdistrikt  opretPostdistrikt ( int postnr, String distrikt )
  {
    Postdistrikt  postdistrikt  = new Postdistrikt  (postnr, distrikt);
    postdistriktCollection.add(postdistrikt);
    return postdistrikt;
  }

  public  Iterator  getPostdistriktIterator ()
  {
    return postdistriktCollection.iterator();
  }
}
